#include "adventureScene.h"

CAdventureScene::CAdventureScene(void)
{	
	in_file.open("scenario.txt");
	adventureBgm_play=false;
	adventureBgm.setLoopMode(true);
	this->init();
	

}

CAdventureScene::~CAdventureScene(void)
{
}

void CAdventureScene::adventureScene(fk_Scene *scene)
{

	sceneNum++;

	switch (sceneNum){

			case 1:
				messageDown.setImage(messageLight);
				scene->entryOverlayModel(&messageDown);
				scene->entryOverlayModel(&textDown);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
			case 2:
				charaLeft.setImage(charaNageru);
				charaRight.setImage(charaIno);
				scene->entryOverlayModel(&charaLeft);
				scene->entryOverlayModel(&textDown);
				scene->entryOverlayModel(&textDownName);
				textDown.drawText(readBuffer[sceneNum],true);
				textDownName.drawText("iQ",true);
				textDown.setPositionLT(-280,-130);
				textDownName.setPositionLT(-280,-110);
				break;
			case 3:	
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
			case 4:
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
			case 5:
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
			case 6:
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
			case 7:
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
			case 8:
				messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				scene->entryOverlayModel(&messageUp);
				scene->entryOverlayModel(&charaLeft);
				scene->entryOverlayModel(&charaRight);
				scene->entryOverlayModel(&textUpName);
				scene->entryOverlayModel(&textUp);
				textUpName.drawText("Cm",true);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				textUpName.setPositionLT(-280,210);
				break;
			case 9:
				messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
			case 10:
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
			case 11:
				messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
			case 12:
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
			case 13:
				messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
			case 14:
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
			case 15:
				messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
			case 16:
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
			case 17:
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
			case 18:
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;

			case 19:
				messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;

			case 20:
				messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;

			case 21:
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);

				break;

			case 22:
				messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;

			case 23:
				messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);

				break;

			case 24:
				this->end(scene);
				break;

			case 25:
				messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				charaLeft.setImage(charaNageru);
				charaRight.setImage(charaIno);
				scene->entryOverlayModel(&messageDown);
				scene->entryOverlayModel(&messageUp);
				scene->entryOverlayModel(&charaLeft);
				scene->entryOverlayModel(&charaRight);
				scene->entryOverlayModel(&textDown);
				scene->entryOverlayModel(&textDownName);
				scene->entryOverlayModel(&textUp);
				scene->entryOverlayModel(&textUpName);
				textDownName.drawText("iQ",true);
				textDownName.setPositionLT(-280,-110);
				textUpName.drawText("Cm",true);
				textUpName.setPositionLT(-280,210);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);

				break;
			case 26:
				messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
			case 27:
				messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
			case 28:
				messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
			case 29:
				messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;

			case 30:
				this->end(scene);

				break;


case 31:
messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				charaLeft.setImage(charaNageru);
				charaRight.setImage(charaIno);
				scene->entryOverlayModel(&messageDown);
				scene->entryOverlayModel(&messageUp);
				scene->entryOverlayModel(&charaLeft);
				scene->entryOverlayModel(&charaRight);
				scene->entryOverlayModel(&textDown);
				scene->entryOverlayModel(&textDownName);
				scene->entryOverlayModel(&textUp);
				scene->entryOverlayModel(&textUpName);
				textDownName.drawText("iQ",true);
				textDownName.setPositionLT(-280,-110);
				textUpName.drawText("Cm",true);
				textUpName.setPositionLT(-280,210);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
case 32:
			
messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
case 33:
				
messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
case 34:
				
textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
case 35:
			
messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
case 36:
			
messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
	case 37:
		this->end(scene);
				break;
					case 38:
				
messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				charaLeft.setImage(charaNageru);
				charaRight.setImage(charaBonta);
				charaMiddle.setImage(charaIno);
				scene->entryOverlayModel(&messageDown);
				scene->entryOverlayModel(&messageUp);
				scene->entryOverlayModel(&charaLeft);
				scene->entryOverlayModel(&charaRight);
				scene->entryOverlayModel(&textDown);
				scene->entryOverlayModel(&textDownName);
				scene->entryOverlayModel(&textUp);
				scene->entryOverlayModel(&textUpName);
				textDownName.drawText("iQ",true);
				textDownName.setPositionLT(-280,-110);
				textUpName.drawText("",true);
				textUpName.setPositionLT(-280,210);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
					case 39:
				messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);

				break;
case 40:
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);

				
				break;
	case 41:
messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 42:
				textUpName.drawText("{",true);
				textUpName.setPositionLT(-280,210);
					textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 43:
					textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 44:
	messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 45:
textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
			case 46:
textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 47:
					messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 48:
					textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 49:
					textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 50:
					messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 51:

					messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				scene->entryOverlayModel(&messageUp);
				scene->entryOverlayModel(&charaMiddle);
				scene->entryOverlayModel(&textUp);
				scene->entryOverlayModel(&textUpName);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
					textUpName.drawText("Cm",true);
				textUpName.setPositionLT(-280,210);
				break;
				case 52:
						messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
			
				case 53:
messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 54:
messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 55:
					this->end(scene);
				break;
				
				case 56:
messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				charaLeft.setImage(charaNageru);
				charaRight.setImage(charaBonta);
				scene->entryOverlayModel(&messageDown);
				scene->entryOverlayModel(&messageUp);
				scene->entryOverlayModel(&charaLeft);
				scene->entryOverlayModel(&charaRight);
				scene->entryOverlayModel(&textDown);
				scene->entryOverlayModel(&textDownName);
				scene->entryOverlayModel(&textUp);
				scene->entryOverlayModel(&textUpName);
				textDownName.drawText("iQ",true);
				textDownName.setPositionLT(-280,-110);
				textUpName.drawText("{",true);
				textUpName.setPositionLT(-280,210);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 57:
messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 58:
					messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 59:
						textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 60:
						textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 61:
messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 62:
					this->end(scene);
				break;
				case 63:
			messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				charaLeft.setImage(charaNageru);
				charaRight.setImage(charaRock);
				charaMiddle.setImage(charaIno);
				scene->entryOverlayModel(&messageDown);
				scene->entryOverlayModel(&messageUp);
				scene->entryOverlayModel(&charaLeft);
				scene->entryOverlayModel(&charaMiddle);
				scene->entryOverlayModel(&textDown);
				scene->entryOverlayModel(&textDownName);
				scene->entryOverlayModel(&textUp);
				scene->entryOverlayModel(&textUpName);
				textDownName.drawText("iQ",true);
				textDownName.setPositionLT(-280,-110);
				textUpName.drawText("Cm",true);
				textUpName.setPositionLT(-280,210);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 64:
messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 65:
					messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 66:
messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				scene->entryOverlayModel(&messageUp);
				scene->entryOverlayModel(&charaLeft);
				scene->entryOverlayModel(&charaMiddle);
				scene->entryOverlayModel(&charaRight);
scene->entryOverlayModel(&textUp);
				scene->entryOverlayModel(&textUpName);
		textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
					textUpName.drawText("bNLO",true);
				textUpName.setPositionLT(-280,210);
				break;
				case 67:
	textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 68:
messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 69:
					messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
					textUpName.drawText("Cm",true);
				textUpName.setPositionLT(-280,210);
				break;
				case 70:
messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 71:
					messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
					textUpName.drawText("bNLO",true);
				textUpName.setPositionLT(-280,210);
				break;
				case 72:
					this->end(scene);
				break;
				case 73:
messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				charaLeft.setImage(charaNageru);
				charaRight.setImage(charaRock);
				scene->entryOverlayModel(&messageDown);
				scene->entryOverlayModel(&messageUp);
				scene->entryOverlayModel(&charaLeft);
				scene->entryOverlayModel(&charaRight);
				scene->entryOverlayModel(&textDown);
				scene->entryOverlayModel(&textDownName);
				scene->entryOverlayModel(&textUp);
				scene->entryOverlayModel(&textUpName);
				textDownName.drawText("iQ",true);
				textDownName.setPositionLT(-280,-110);
				textUpName.drawText("bNLO",true);
				textUpName.setPositionLT(-280,210);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);

				break;
				case 74:
					messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 75:
					messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 76:
messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 77:
					textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 78:
					textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 79:
					messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 80:
					messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 81:
					messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 82:
						textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 83:
					messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 84:
					charaRight.setImage(charaDummy);
	textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				textUp.drawText("",true);
				textUp.setPositionLT(-280,190);
					textUpName.drawText("",true);
				textUpName.setPositionLT(-280,210);
				break;
				case 85:
						textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 86:
						textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 87:
					charaRight.setImage(charaIno);
textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
					textUpName.drawText("Cm",true);
				textUpName.setPositionLT(-280,210);
				break;
				case 88:
					textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 89:
						messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 90:
textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 91:
					messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 92:
					textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 93:
					messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 94:
					messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 95:
						messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 96:
					textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 97:
							messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 98:
					messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 99:
					messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 100:
					textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 101:
						messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 102:
					messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 103:
							messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 104:
						textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 105:
					messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 106:
					messageUp.setImage(messageLight);
				messageDown.setImage(messageDark);
				textUp.drawText(readBuffer[sceneNum],true);
				textUp.setPositionLT(-280,190);
				break;
				case 107:
						messageDown.setImage(messageLight);
				messageUp.setImage(messageDark);
				textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 108:
						textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-130);
				break;
				case 109:
				
				scene->removeOverlayModel(&messageUp);
				scene->removeOverlayModel(&charaLeft);
				scene->removeOverlayModel(&charaRight);
				
				scene->removeOverlayModel(&textDownName);
				scene->removeOverlayModel(&textUp);
				scene->removeOverlayModel(&textUpName);
						textDown.drawText(readBuffer[sceneNum],true);
				textDown.setPositionLT(-280,-115);
				break;
				case 110:
					this->end(scene);
				break;
				
	
			default:
				
				this->end(scene);

				break;
	}

		

}

void CAdventureScene::adventure(fk_Window *window,fk_Scene *scene,CInput *input,int sceneNumInput)
{
		if(adventureEnd==false){
	if(sceneNum==-1){
	
	charaLeft.MakePixelBase(window, scene);	
	charaRight.MakePixelBase(window, scene);
	charaMiddle.MakePixelBase(window,scene);
	messageDown.MakePixelBase(window, scene);
	textDown.MakePixelBase(window, scene);
	messageUp.MakePixelBase(window, scene);
	textUp.MakePixelBase(window, scene);
	textDownName.MakePixelBase(window, scene);
	textUpName.MakePixelBase(window, scene);
	sceneNum=sceneNumInput-1;
	this->adventureScene(scene);

	}




	if(input->checkDown(INPUT_4,KEY|PAD1)){
			
			this->adventureScene(scene);
			
			

		}

	if(input->checkPress(INPUT_5,KEY|PAD1)){
			this->adventureScene(scene);
		}
	if(textDown.text.getAllCharNum()>0){
		textDown.text.send();
	}
		if(textUp.text.getAllCharNum()>0){
		textUp.text.send();
	}
	
	}
}

