//---------------------------------------------------
// ^Cg
//---------------------------------------------------

#include "title.h"

CTitle::CTitle()
{
	cursorNum = 0;
}

CTitle::~CTitle()
{
}

void CTitle::init()
{
	DB->graphDB.setImage( "titleimage", "dat/graph/title/titleimage.png" );
	DB->graphDB.setPositionLT( "titleimage", -WINDOW_WIDTH/2.0, WINDOW_HEIGHT/2.0);
	//DB->graphDB.setImage( "gamestart", "dat/graph/title/gamestart.png" );
	//DB->graphDB.setPositionLT( "gamestart", -72.5 , -100.0);
	DB->graphDB.setImage( "singlemode", "dat/graph/title/singlemode.png" );
	DB->graphDB.setPositionLT( "singlemode", -72.5 , -70.0);
	DB->graphDB.setImage( "vsmode", "dat/graph/title/vsmode.png" );
	DB->graphDB.setPositionLT( "vsmode", -72.5 , -100.0);
	DB->graphDB.setImage( "option", "dat/graph/title/option.png" );
	DB->graphDB.setPositionLT( "option", -72.5 , -130.0);
	DB->graphDB.setImage( "ranking", "dat/graph/title/ranking.png" );
	DB->graphDB.setPositionLT( "ranking", -72.5 , -160.0);	
	//DB->graphDB.setImage( "quit", "dat/graph/title/quit.png" );
	//DB->graphDB.setPositionLT( "quit", -72.5 , -150.0);
	DB->graphDB.setImage( "endgame", "dat/graph/title/endgame.png" );
	DB->graphDB.setPositionLT( "endgame", -72.5 , -190.0);
	DB->graphDB.setImage( "cursor", "dat/graph/interface/cursor.png" );
	DB->graphDB.setPositionLT( "cursor", -120.0, -70.0);
}

bool CTitle::onPeriod()
{
	/*
	//vZ
	*/
	if( input->checkDown( INPUT_UP ) )
	{
		cursorNum --;
	}
	if( input->checkDown( INPUT_DOWN ) )
	{
		cursorNum ++;
	}

	if( cursorNum < 0)
	{
		cursorNum = 4;
	}
	if( cursorNum > 4)
	{
		cursorNum = 0;
	}

	if( input->checkDown( INPUT_1 ) )
	{
		if( cursorNum == 0)
		{
			*scene = S_CHARASELECT;
			DB->graphDB.removeImage( "titleimage" );
			DB->graphDB.removeImage( "gamestart" );
			DB->graphDB.removeImage( "quit" );
			DB->graphDB.removeImage( "cursor" );
			return true ;
		}
		if( cursorNum == 1)
		{
			*scene = S_END;
			return true ;
		}
	}

	

	/*
	//`揈
	*/
	DB->graphDB.setPositionLT( "cursor", -120.0, -70.0 + -(30*cursorNum));

	
	return false ;
}
