#pragma once
#include "database.h"
#include "effectHeal.h"
#include "effectThrowHit.h"
#include "effectFire.h"
#include "effectAnimaRushHit.h"
#include "adventureScene.h"
#include "effectRepair.h"
#include "effectAnimaThrowHit.h"
#include "effectSlash.h"
#include "effectDamage.h"

class CEffect
{
public:
	CEffectHeal				heal;
	CEffectThrowHit			throwHit;
	CEffectFire				fire;
	CEffectAnimaRushHit		rush;

	CEffectRepair			repair;
CEffectAnimaThrowHit		Animathrow;
CEffectSlash				slash;
CEffectDamage				damage;


	CEffect(void);
	~CEffect(void);

	void init(CDatabase *DB);
	void update(CDatabase *DB);

};
