#include "effectDamage.h"

CEffectDamage::CEffectDamage(void)
{
	for(int i=0;i<4;i++){
	DamageT[i]=-1;
	}

	DamageN=0;
	
	
}

CEffectDamage::~CEffectDamage(void)
{
	
}



void CEffectDamage::effectSet(CDatabase *DB, fk_Model *Target)
{
	if(DamageN>3){ 
		DamageN=0;
	}
	effectPos=Target->getPosition();

	DB->effectDB.glMoveTo(this->setNum(DamageN),(effectPos.x)+rand()%60-30,(effectPos.y)+rand()%60-30,(effectPos.z)-10);
	
	DB->effectDB.entryEffect(this->setNum(DamageN));
	DamageT[DamageN]=30;


	DamageN++;
}

void CEffectDamage::update(CDatabase *DB)
{

	for(int i=0;i<4;i++){

		if(DamageT[i]>0){
DamageT[i]--;

		DB->effectDB.focusCamera(this->setNum(i) , DB->systemDB.getCamera() );
		DB->effectDB.setScale(this->setNum(i),0.9,0.9);
		
		}
		
		if(DamageT[i]==0){
				DB->effectDB.setScale(this->setNum(i),1/pow(0.9,30),1/pow(0.9,30));

			this->effectDelete(DB,i);
			DamageT[i]=-1;

		}
	}
	
}

void CEffectDamage::effectDelete(CDatabase *DB,int a)
{
	DB->effectDB.glMoveTo(this->setNum(a),effectPos);
	
	DB->effectDB.removeEffect(this->setNum(a));

}

void CEffectDamage::init(CDatabase *DB)
{
	for(int i=0;i<4;i++){
		DB->effectDB.createEffectBlack(this->setNum(i),  "dat/effect/galaxy126_2.png" , 1 , 1 );
	DB->effectDB.setSize( this->setNum(i) , 150.0 , 150.0 );

	DB->effectDB.setRendMode(this->setNum(i));
	DB->effectDB.focusCamera( this->setNum(i) , DB->systemDB.getCamera() );
	}


	
	
}


std::string CEffectDamage::setNum(int a)
{
	std::string DamageN="Damage"+a;
 return DamageN;
}
