#include "effectHeal.h"

CEffectHeal::CEffectHeal(void)
{
		iT=-1;
		effectMove.set(0,2,0);
		
}

CEffectHeal::~CEffectHeal(void)
{
}

void CEffectHeal::effectSet(CDatabase *DB, fk_Model *Target)
{
		if(iT==-1){
			
				
					DB->effectDB.setParent("heal",Target);
					DB->effectDB.glMoveTo("heal",0,0,0);
						
					DB->effectDB.entryEffect("heal");
				
					iT=60;
					
		}
}

void CEffectHeal::update(CDatabase *DB)
{

		if(iT>0){
iT--;
		DB->effectDB.focusCamera( "heal" , DB->systemDB.getCamera() );
		}
		if(iT>45){
			DB->effectDB.glTranslate("heal",effectMove);
		}
		if(iT==45){
		
			DB->effectDB.glMoveTo("heal",0,0,0);
		}
			if(iT>30&&iT<45){
				
			DB->effectDB.glTranslate("heal",effectMove);
		}
		if(iT==30){

			DB->effectDB.glMoveTo("heal",0,0,0);
		}
			if(iT>15&&iT<30){
					
			DB->effectDB.glTranslate("heal",effectMove);
		}
		if(iT==15){
		
			DB->effectDB.glMoveTo("heal",0,0,0);
		}
			if(iT>0&&iT<15){
			
		DB->effectDB.glTranslate("heal",effectMove);
		}
		if(iT==0){
			this->effectDelete(DB);
			iT=-1;

		}
	
}

void CEffectHeal::effectDelete(CDatabase *DB)
{
	
	DB->effectDB.deleteParent("heal");
	DB->effectDB.removeEffect("heal");

}

void CEffectHeal::init(CDatabase *DB)
{
	DB->effectDB.createEffect( "heal" , "dat/effect/star-kaifuku0906.png" , 1 , 1 );
	DB->effectDB.setSize( "heal" , 100.0 , 100.0 );
	DB->effectDB.setRendMode("heal");
	DB->effectDB.focusCamera( "heal" , DB->systemDB.getCamera() );
}
