//---------------------------------------------------
// 摜֌Wf[^x[X
//---------------------------------------------------

#include "graphDB.h"

CGraphDB::CGraphDB()
{
}

CGraphDB::~CGraphDB()
{
	deleteImageAll();
}

/*
 fk_Windowfk_ScenẽAhXZbg
 */
void CGraphDB::setAddress( fk_Window *w , fk_Scene *s )
{
	window = w ;
	scene = s ;
}

/*
 摜Zbg
 */
void CGraphDB::setImage( std::string name , std::string pass )
{
	if( findImage( name ) )
	{
		entryImage( name );
		return ;
	}
	img.insert( std::make_pair( name , new fkut_SpriteModel() ) );
	imgIte = img.find( name );
	if( !(*imgIte).second->readPNG( pass ) )
	{
		if( !(*imgIte).second->readJPG( pass ) )
		{
			fl_alert( "read error [%s]" , pass.c_str() );
			deleteImage( name );
			return ;
		}
	}
	(*imgIte).second->entryFirst( window , scene );
}

/*
 摜폜
 */
void CGraphDB::deleteImage( std::string name )
{
	if( findImage( name ) )
	{
		scene->removeOverlayModel( (*imgIte).second );
		delete (*imgIte).second ;
		(*imgIte).second = NULL ;
		img.erase( name );
	}
}

/*
 S摜폜
 */
void CGraphDB::deleteImageAll()
{
	for( imgIte = img.begin() ; imgIte != img.end() ; imgIte ++ )
	{
		scene->removeOverlayModel( (*imgIte).second );
		delete (*imgIte).second ;
		(*imgIte).second = NULL ;
	}
	img.clear();
}

/*
 w肳ꂽỎ摜true
 */
bool CGraphDB::findImage( std::string name )
{
	imgIte = img.find( name );
	return ( imgIte != img.end() ) ;
}

/*
 fkut_SpriteModel::setPositionLTƓAW(left,top)ɂȂ悤ɉ摜ړ
 */
void CGraphDB::setPositionLT( std::string name , double left , double top )
{
	if( findImage( name ) )
	{
		(*imgIte).second->setPositionLT( left , top );
	}
}

/*
 fkut_SpriteModel::setSpriteAreaƓA摜\̈ݒ
 */
void CGraphDB::setSpriteArea( std::string name , double left , double top , double width , double height )
{
	if( findImage( name ) )
	{
		(*imgIte).second->setSpriteArea( left , top , width , height );
	}
}

/*
 fkut_SpriteModel::setSpriteSizeƓA摜\TCYݒ
 */
void CGraphDB::setSpriteSize( std::string name , double width , double height )
{
	if( findImage( name ) )
	{
		(*imgIte).second->setSpriteSize( width , height );
	}
}

/*
 ͂`i`悷镶́FdrawStringj
 */
void CGraphDB::setString( std::string name , std::string drawString )
{
	/*
	if( findImage( name ) )
	{
		//fk_UniStr	uStr ;
		//uStr.convert( drawString , FK_STR_UTF16 );
		//scene->entryModel( (*imgIte).second );
		(*imgIte).second->text.initFont( "C:/WINDOWS/Fonts/Meiryo.ttc" );
		//(*imgIte).second->text.loadUniStr( &uStr );	// \Ȃ
		//(*imgIte).second->text.finish();
		(*imgIte).second->drawText( drawString , true );
	}
	*/
}

/*
 fk_Scene::entryOverlayModelƓAfo^
 */
void CGraphDB::entryImage( std::string name )
{
	if( findImage( name ) )
	{
		scene->entryOverlayModel( (*imgIte).second );
	}
}

/*
 fk_Scene::entryOverlayModelƓAf
 */
void CGraphDB::removeImage( std::string name )
{
	if( findImage( name ) )
	{
		scene->removeOverlayModel( (*imgIte).second );
	}
}
