//---------------------------------------------------
// V[x[X
//---------------------------------------------------

#pragma once

#include "common.h"
#include "database.h"
#include "cInput.h"

enum eScene
{
	S_TITLE ,		// ^Cg
	S_OPTION ,		// IvV
	S_SINGLEMODE ,	// VO[h
	S_ADVENTURE ,	// Ahx`[p[g
	S_VSMODE ,		// VS[h
	S_CHARASELECT ,	// LN^[ZNg
	S_RESULT ,		// Ug
	S_ENDING ,		// GfBO
	S_GAMEOVER ,	// Q[I[o[
	S_STAGEEDITOR ,	// Xe[WGfB^
	S_END = -1 ,	// I
};

class CSceneBase
{
private:

protected:
	eScene		*scene ;
	CDatabase	*DB ;
	CInput		*input ;

public:
	virtual ~CSceneBase(){};

	virtual void	init() = 0 ;
	virtual bool	onPeriod() = 0 ;

	void			setAddress( eScene *e , CDatabase *d , CInput *i );

};
