#pragma once
#include "common.h"

#include "database.h"

class CSound {
private:
	bool	isPlayMainBGM;
	bool	isPlayRockingBGM;
	bool	isPlayBontaBGM;
	bool	isPlayBattleBGM;

public:
	CSound(void);
	~CSound(void);

	void init(CDatabase *DB);

	void playMainBGM(CDatabase *DB);	//CBGMĐ
	void stopMainBGM(CDatabase *DB);	//CBGM~
	bool getMainBGMStatus();

	void playRockingBGM(CDatabase *DB);	//bNLOBGMĐ
	void stopRockingBGM(CDatabase *DB);	//bNLOBGM~
	bool getRockingBGMStatus();

	void playBontaBGM(CDatabase *DB);	//{BGMĐ
	void stopBontaBGM(CDatabase *DB);	//{BGM~
	bool getBontaBGMStatus();

	void playBattleBGM(CDatabase *DB);	//{BGMĐ
	void stopBattleBGM(CDatabase *DB);	//{BGM~
	bool getBattleBGMStatus();

	void playEditorBGM(CDatabase *DB);	//{BGMĐ
	void stopEditorBGM(CDatabase *DB);	//{BGM~
	bool getEditorBGMStatus();

	void playSelectSE(CDatabase *DB);	//J[\ZNgSE

	void playJumpSE(CDatabase *DB);		//WvSEĐ
	void playDamageSE(CDatabase *DB);	//_[WSEĐ
	void playLiftSE(CDatabase *DB);		//ubNグSEĐ
	void playFallSE(CDatabase *DB);		//SEĐ
	void playSlashSE(CDatabase *DB);		//ߐڍUSEĐ
	void playThrowSE(CDatabase *DB);		//SEĐ
	
	void playSummonAnimaSE(CDatabase *DB);//Aj}SEĐ
	void playAnimaThrowSE(CDatabase *DB);//Aj}X[SEĐ
	void playAnimaRushSE(CDatabase *DB);		//Aj}bVSEĐ
	void playAnimaRepairSE(CDatabase *DB);		//Aj}yASEĐ
	void playAnimaCureSE(CDatabase *DB);		//Aj}yASEĐ

	void playPlayerDeathSE(CDatabase *DB);		//vC[SSEĐ

	void playEnemyDamageSE(CDatabase *DB);		//G_[WSEĐ
	void playEnemyLandingSE(CDatabase *DB);		//GnSEĐ
	void playEnemyDeathSE(CDatabase *DB);		//GSSEĐ

	void playGaugeFullSE(CDatabase *DB);	//Aj}Q[W}bNXSE

	void deleteSound(CDatabase *DB);

	void debug(CDatabase *DB);				//fobOp
};