//---------------------------------------------------
// Xe[WJ
//---------------------------------------------------

#pragma once

#include "common.h"

class CStageCamera
{
private:
	fk_Model	*camera ;
	fk_Vector	pos , posNow , focus , focusNow ;
	double		angle , height ;

public:
	CStageCamera();
	~CStageCamera();

	void	setAddress( fk_Model *c );
	void	updateSingle( fk_Vector playerPos );
	void	updateVS( fk_Vector p1Pos , fk_Vector p2Pos );
	void	setFocusToEnemy( fk_Vector playerPos , fk_Vector enemyPos );
	void	addAngle( double a );
	void	addHeight( double h );
	void	setAngle( double a );
	void	setHeight( double h );
	double	getAngle();
	double	getHeight();

};
