#include "common.h"

CLifThrow::CLifThrow(fk_Vector pos)
{
	fk_Material::initDefault();
	
	//vC[f̈ʒuֈړ
	parentLiftBlockModel.glMoveTo(pos);
	parentThrowBlockModel.glMoveTo(pos);

	//parentLidtBlockModel𒆐SɘZp``悤ɔzu
	liftBlockModel[0].glMoveTo(parentLiftBlockModel.getPosition().x, parentLiftBlockModel.getPosition().y, parentLiftBlockModel.getPosition().z-(20.0*2/3));
	liftBlockModel[1].glMoveTo(parentLiftBlockModel.getPosition().x+(17.3*2/3), parentLiftBlockModel.getPosition().y, parentLiftBlockModel.getPosition().z-(10.0*2/3));
	liftBlockModel[2].glMoveTo(parentLiftBlockModel.getPosition().x+(17.3*2/3), parentLiftBlockModel.getPosition().y, parentLiftBlockModel.getPosition().z+(10.0*2/3));
	liftBlockModel[3].glMoveTo(parentLiftBlockModel.getPosition().x, parentLiftBlockModel.getPosition().y, parentLiftBlockModel.getPosition().z+(20.0*2/3));
	liftBlockModel[4].glMoveTo(parentLiftBlockModel.getPosition().x-(17.3*2/3), parentLiftBlockModel.getPosition().y, parentLiftBlockModel.getPosition().z+(10.0*2/3));
	liftBlockModel[5].glMoveTo(parentLiftBlockModel.getPosition().x-(17.3*2/3), parentLiftBlockModel.getPosition().y, parentLiftBlockModel.getPosition().z-(10.0*2/3));

	for(int i = 0; i < 6; i++ )
	{
		liftObb[i].setBlockSize(8.0, 8.0, 8.0);
		liftObb[i].setModel(&liftBlockModel[i]);
		liftBlock[i].setSize(8.0, 8.0, 8.0);
		liftBlockModel[i].setMaterial(Purple);
		liftBlockModel[i].setParent( &parentLiftBlockModel, true);
		liftBlockModel[i].setShape(&liftBlock[i]);
		isLiftBlockFlag[i] = false;
	}

	
	for(int i = 0; i < 6; i++ )
	{
		throwBlockModel[i].glMoveTo(parentThrowBlockModel.getPosition().x, parentThrowBlockModel.getPosition().y+16, parentThrowBlockModel.getPosition().z);
		throwObb[i].setBlockSize(8.0, 8.0, 8.0);
		throwObb[i].setModel(&throwBlockModel[i]);
		throwBlock[i].setSize(8.0, 8.0, 8.0);
		throwBlockModel[i].setMaterial(Gray1);
		throwBlockModel[i].setParent( &parentThrowBlockModel, true);
		throwBlockModel[i].setShape(&throwBlock[i]);
		isThrowBlockFlag[i] = false;
		throwBlockDistance[i] = 0;
		isHitThrowBlock[i] = false;
	}
	
	liftBlockCount = 0;

	throwBlockSpd = (0, 0, 0);

	attackDamage = 0;
};

CLifThrow::~CLifThrow(void)
{
};

void CLifThrow::entryScene(fk_Scene *argScene)
{
	for(int i = 0; i < 6; i++) {
		argScene->entryModel(&liftBlockModel[i]);
		argScene->entryModel(&throwBlockModel[i]);
	}

	return;
}


//グubN]
void CLifThrow::rotationLiftBlock()
{
	parentLiftBlockModel.loFocus(0.07, 0.0, -1.0);
	return;
}

//グubN̐efړ
void CLifThrow::setLiftBlockPos(fk_Vector pos)
{
	parentLiftBlockModel.glMoveTo(pos);
	parentThrowBlockModel.glMoveTo(pos);
	return;
}

//グubN`攻菈
void CLifThrow::drawLiftBlock()
{
	for(int i = 0; i < 6; i++ )
	{
		if( isLiftBlockFlag[i] == true )
		{
			liftBlockModel[i].setDrawMode(FK_POINTMODE | FK_LINEMODE | FK_POLYMODE);
		}
		else
		{
			liftBlockModel[i].setDrawMode(FK_NONEMODE);	
		}
	}
	return;
}

//グubN̈ʒuA܂グ\ǂ̔菈
void CLifThrow::setLiftBlockNum()
{
	if(liftBlockCount < 6)//ubNグĂ鐔6̎
	{
		for(int i = 0; i < 6; i++ )
		{
			if(isThrowBlockFlag[i] == false )//YubNĂrłȂǂ
			{
				if(isLiftBlockFlag[i] == false )//YubNɊɎグubNo^ĂȂǂ
				{
					isLiftBlockFlag[i] = true;
					liftBlockCount ++;
					break;
				}
			}
		}
	}

	return;
}

//ubN`攻菈
void CLifThrow::drawThrowBlock()
{
	for(int i = 0; i < 6; i++ )
	{
		if( isThrowBlockFlag[i] == true )
		{
			throwBlockModel[i].setDrawMode(FK_POINTMODE | FK_LINEMODE | FK_POLYMODE);
		}
		else
		{
			throwBlockModel[i].setDrawMode(FK_NONEMODE);	
		}
	}
	return;
}


//ubNppx擾
void CLifThrow::setThrowAngle(fk_Vector pos)
{
	for(int i = 0; i < 6; i++ )
	{
		if(isLiftBlockFlag[i] == true )//グubN邩ǂ
		{	
			if(isThrowBlockFlag[i] == false )//ɓĂȂǂ
			{
				isThrowBlockFlag[i] = true;				//ubN݂锻ɐݒ
				isLiftBlockFlag[i] = false;				//グubN݂Ȃɐݒ
				liftBlockCount --;						//グubN炷
				throwBlockModel[i].deleteParent(true);	//eq֌WOăubNړł悤ɂ
				throwBlockModel[i].glFocus(pos);		//G̕
				isHitThrowBlock[i] = true;				//ubNɓ蔻
				break;//I_ŏf
			}
		}
	}
	return;
}

//ubNx
void CLifThrow::setThrowVector()
{
	for(int i = 0; i < 6; i++ )
	{
		if(isThrowBlockFlag[i] == true )
		{
			throwBlockModel[i].loTranslate(0, 0, -3);	//3Ԗڂ̈ubN̑x
			throwBlockDistance[i] += 3;					//ubNׂ̏̈ɃubN̈ړZ
		}
	}
	return;
}

//OėꂷubN̏tO
void CLifThrow::setThrowBlockFlag()
{
	for(int i = 0; i < 6; i++ )
	{
		if(throwBlockDistance[i] > 400)	//ubN̈ړ400ȏ̎
		{
			isHitThrowBlock[i] = false;										//蔻
			isThrowBlockFlag[i] = false;									//݂Ȃɐݒ
			throwBlockModel[i].setDrawMode(FK_NONEMODE);					//`߂
																			//ÖʒuivC̓jɈړ
			throwBlockModel[i].glMoveTo(parentThrowBlockModel.getPosition().x, parentThrowBlockModel.getPosition().y+16, parentThrowBlockModel.getPosition().z);
			throwBlockModel[i].setParent( &parentThrowBlockModel, true);	//eq֌WĂьŃvCƈꏏɈړ悤ɂ
			throwBlockDistance[i] = 0;										//ړZbg
		}
	}
	return;
}

//ubNf擾
fkut_OBB CLifThrow::getThrowObb(int num)
{
	return throwObb[num];
}

//ubN̉x̃AhX擾
fk_Vector * CLifThrow::getThrowBlockSpdAddress()
{
	return &throwBlockSpd;
}

//Փ˔菈iՓˎ̓ubN܂
bool CLifThrow::checkCollision(int num, fkut_OBB &hitOBB, fk_Vector *spd)
{
	bool judge = false;

	static fk_Vector refV;

	throwBlockModel[num].setMaterial(Gray1);	

	// Փ˔̊Jn
	if(isHitThrowBlock[num] == true )
	{
		if(throwObb[num].checkVSMovingOBB(hitOBB, (*spd), refV )) 
		{
			throwBlockModel[num].setMaterial(Red); 
			judge = true;

			//uOėꂷubN̏tOvƓl̏s
			attackDamage = 2;
			isHitThrowBlock[num] = false;
			isThrowBlockFlag[num] = false;
			throwBlockModel[num].setDrawMode(FK_NONEMODE);
			throwBlockModel[num].glMoveTo(parentThrowBlockModel.getPosition().x, parentThrowBlockModel.getPosition().y+16, parentThrowBlockModel.getPosition().z);
			throwBlockModel[num].setParent( &parentThrowBlockModel, true);
			throwBlockDistance[num] = 0;
		}
	}
		
	return judge;
}

//グubN̎擾
int CLifThrow::getLiftBlockCount()
{
	return liftBlockCount;
}

//_[Wl̎擾
double CLifThrow::getAttackDamage(double comboBonus)
{
	double returnDamage = attackDamage*comboBonus;
	attackDamage = 0;
	return returnDamage;
}

//tX[NX̏ݒ̏
void CLifThrow::initLifThrow()
{
	for(int i = 0; i < 6; i++ )
	{
		isLiftBlockFlag[i] = false;
		isThrowBlockFlag[i] = false;
		throwBlockDistance[i] = 0;
		isHitThrowBlock[i] = false;
	}
	liftBlockCount = 0;
	throwBlockSpd = (0, 0, 0);
	attackDamage = 0;
	return;
}

//fobOp
void CLifThrow::debug()
{
	printf( "%d\n", throwBlockDistance[0]);
	return;
}