/*
//C֐
*/
#include "common.h"

int main(int argc, char *argv[])
{
	Fl_Window		mainWindow(WINDOW_WIDTH, WINDOW_HEIGHT, "LifThrow tX[I");
	fk_Model		lightModel; 
	//fk_Model		spotlightModel;
	fk_Light		light, spotlight;
	fk_Scene		scene;
	fk_Window		window(0, 0, WINDOW_WIDTH, WINDOW_HEIGHT);

	CField			field;

	fkut_FrameController	fc;

	mainWindow.end();
	fk_InitMaterial();

	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.getMaterial()->setAmbDiff(1.0, 1.0, 1.0);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(0.5, -1.0, 0.0);

	//lp
	CPlayer			player;

	//ubNグAp
	CLifThrow		lifThrow(player.getPos());

	//Gp
	CEnemy			enemy;
	CEnemyAttack	enemyAttack(enemy.getPos() );

	//yp
	CSound			sound;

	//Jp
	CCamera			camera;

	//^C}[p
	CTimer			timer;

	//C^[tFCX`p
	CDraw			draw;

	// effBXvCXgɓo^
	player.entryScene(&scene);
	field.entryScene(&scene);
	lifThrow.entryScene(&scene);
	enemy.entryScene(&scene);
	enemyAttack.entryScene(&scene);

	//scene.entryCamera(&camera);
	scene.entryCamera(camera.getCameraModelAddress());
	scene.entryModel(&lightModel);
	//scene.entryModel(&spotlightModel);

	draw.entryScene(&scene, &window);


	// EBhEփfBXvCXgo^
	window.setScene(&scene);

	mainWindow.show();
	window.show();

	//V[؂ւ
	int gameScene = 0;

	//J[\؂ւ
	int cursolNum = 0;

	//JEgb菈
	int count = 0;

	/*
	//[v
	*/
	while(true) {
		fc.TimeRegular();

		if(mainWindow.visible() == 0) 
		{
			if(Fl::wait() == 0)
			{
				break;
			}
			else
			{
				continue;
			}
		}

		if(fc.GetDrawFlag()) window.drawWindow();
		if(Fl::check() == 0) break;
		if(window.winOpenStatus() == false) continue;

		/*
		//^CgV[
		*/
		if( gameScene == 0)
		{
			static bool prevSelect = false;

			//L[
			if(window.getSpecialKeyStatus(FK_UP, false) & !prevSelect) 
			{
				cursolNum --;				
			}
			prevSelect = window.getSpecialKeyStatus(FK_UP, false);
			//L[
			if(window.getSpecialKeyStatus(FK_DOWN, false) & !prevSelect) 
			{
				cursolNum ++;
			}
			prevSelect = window.getSpecialKeyStatus(FK_DOWN, false);
			//L[
			if(window.getSpecialKeyStatus(FK_LEFT, false) & !prevSelect) 
			{
				cursolNum --;
			}
			prevSelect = window.getSpecialKeyStatus(FK_LEFT, false);
			//EL[
			if(window.getSpecialKeyStatus(FK_RIGHT, false) & !prevSelect) 
			{
				cursolNum ++;
			}
			prevSelect = window.getSpecialKeyStatus(FK_RIGHT, false);

			if( cursolNum < 0)
			{
				cursolNum = 0;
			}
			if( cursolNum > 1)
			{
				cursolNum = 1;
			}

			if(window.getKeyStatus('Z', false))
			{
				if( cursolNum == 0)
				{
					gameScene = 1;
				}
				else if(cursolNum == 1 )
				{
					return -1;
				}
			}

			draw.removeScene(&scene);
			draw.drawTitle(cursolNum, &scene);
		}
		/*
		//CQ[V[
		*/
		else if( gameScene == 1)
		{
			static bool prevJump = false;
			static bool prevLift = false;
			static bool prevThrow = false;
			static bool prevMusic = false;
			static bool prevAttack = false;

			if(fc.GetDrawFlag()) window.drawWindow();
			if(Fl::check() == 0) break;
			if(window.winOpenStatus() == false) continue;

			// J XZ Ƃɐis
			player.setView(camera.getCameraVec());

			// Wv̏x XZ ̊x悹
			if(	player.getIsJump() == false && player.getIsCanMove() == true)//Wv\ǂ̔
			{
				if(window.getKeyStatus('C', false) & !prevJump ) {
					player.jumpAction(false);
					sound.playJumpSE();
				}
				prevJump = window.getKeyStatus('C', false);
			}

			// n㎞͓x^A󒆂ł͉x
			player.initSpd();


			//sړ
			if(player.getIsCanMove() == true && player.getIsAttack() == 0 )//sړ̂ǂ
			{
				//ꂼFWAFQAEFUAFSɂƂ@ieL[Ql
				if(window.getSpecialKeyStatus(FK_UP, false)) {
					player.moveAction(8);
				}
				if(window.getSpecialKeyStatus(FK_DOWN, false)) {
					player.moveAction(2);
				}
				if(window.getSpecialKeyStatus(FK_LEFT, false)) {
					player.moveAction(4);
				}
				if(window.getSpecialKeyStatus(FK_RIGHT, false)) {
					player.moveAction(6);
				}
			}
			player.normSpd();//ŌݒɍsĂiۂ̕ύX͈ړ̏ŕsčs

			// d͉x
			player.setGravity();

			// x𑬓xɏ悹
			player.addAcc();

			//ubÑ_bV
			player.dashAction();

			//ړɏċ͂Ȓi@Ÿړ͌ŏ
			player.translatePlayerXZ();
			//vC[ƃtB[h̃ubNƂ̏Փ˔Ăяo
			if(field.checkCollision(player.getOBB(), player.getPSpd() ) )
			{
				player.initAcc();
			}

			//vC[ƓGƂ̏Փ˔
			if( player.getDamageState() == false )
			{
				if(enemy.checkCollision(player.getOBB(), player.getPSpd()))
				{
					player.setDamageState(1);//vC[ւ̃_[Wi̓_[W
					sound.playDamageSE();
				}
			}

			//vC[ƓGeƂ̏Փ˔
			if( player.getDamageState() == false )
			{
				if(enemyAttack.checkBulletCollision(player.getOBB(), player.getPSpd()))
				{
					player.setDamageState(1);//vC[ւ̃_[Wi̓_[W
					sound.playDamageSE();
					enemyAttack.initBulletPos(enemy.getPos());
				}
			}

			//ꂩ痎̏
			if( player.setFallState() == true)
			{
				sound.playFallSE();;
				player.setDamageState(1);//vC[ւ̃_[Wi̓_[W
			}


			//Ÿړs@XZ̈ړ͏ōsĂ
			player.translatePlayerY();
			// + G̕փvČ̕ύX
			player.setVecEnemy(enemy.getPos());


			//グubN̈ʒuꏏɈړ
			lifThrow.setLiftBlockPos(player.getPos());
			lifThrow.rotationLiftBlock();


			//Jړ
			camera.getCameraMovePos(player.getPos(), player.getPlayerVec(), enemy.getPos() );

			//͂ݏ
			if(player.getIsCanMove() == true )	//\ǂ̔
			{
				if(window.getKeyStatus('V', false) & !prevLift) //L[ꂽ
				{
					if(lifThrow.getLiftBlockCount() < 6 ) //ĂubN̐UȂ
					{
						if( field.getJudgeCatch() > 1 ) //グ\ȃubNǂ
						{
							lifThrow.setLiftBlockNum();
							field.setBlockCatch();
							//Wv
							player.jumpAction(true);

							sound.playLiftSE();
						}
					}
				}
				prevLift = window.getKeyStatus('V', false);

				//꓊
				if(window.getKeyStatus('X', false) & !prevThrow) //L[ꂽƂ
				{
					if( lifThrow.getLiftBlockCount() > 0 ) //グĂubN̐PȏȂ
					{
						//ubNu
						lifThrow.setThrowAngle(enemy.getPos());
						//_bVԂ
						player.setIsDash();

						sound.playThrowSE();
					}
				}
				prevThrow = window.getKeyStatus('X', false);
			}

			//ubN̉x
			lifThrow.setThrowVector();
			//ubN̏
			lifThrow.setThrowBlockFlag();

			//Uf̕
			if(player.getIsAttack() == 0)//UĂȂ␳
			{
				player.setAttackVec(player.getPlayerVec());
			}
			//ߐڍU
			player.attackAction();
			if( timer.getTime()*100 > 0.5)//Q[JnɂߐڍUĂ܂Ȃ悤ɂb菈
			{
				if(window.getKeyStatus('Z', false) & !prevAttack)
				{
					//UԂ
					player.setAttack();
				}
			}
			prevAttack = window.getKeyStatus('Z', false);

			// GƓubN̏Փ˔Ăяo
			//enemyɏՓ˔菈݂AforœubŇiUj񂵂Ƃ
			//ȂŌ̏(throwObb[5]jtȂlifThrowŔ
			for(int i = 0; i < 6; i++ )
			{
				if(lifThrow.checkCollision(i, enemy.getEnemyObb(), lifThrow.getThrowBlockSpdAddress() ) == true )
				{
					enemy.damageEnemy(lifThrow.getAttackDamage(player.getComboBonus() ) );//Gւ̃_[Wi̓_[W
					player.addLifThrowCombo();	//R{
				}
			}
			
			player.setCombo();

			//GƋߐڍȔՓ˔Ăяo
			if(player.checkAttackCollision(enemy.getEnemyObb(), lifThrow.getThrowBlockSpdAddress() ) == true )
			{
				enemy.damageEnemy(player.getAttackDamage() );//Gւ̃_[Wi̓_[W

				sound.playSlashSE();
			}

			enemy.setAliveFlag();	//GĂ邩̔
			enemy.setDamageState();	//G̐H炢[VI
			//enemy.setInv();	//Gւ̖GԂ̐ݒ

			//ëړ
			player.moveShadow();

			//G̍s
			enemyAttack.setEnemyAlive(enemy.getAliveFlag());

			if(enemy.getAliveFlag() == true)
			{
				if(	enemy.getEnemyAI() % 20 == 0 )
				{
					enemyAttack.setBulletVec();
				}
				enemyAttack.moveBullet();
			}

			//ԍXV
			if(enemy.getAliveFlag() == true)
			{
				timer.addTime(0.0166666667);
			}

			//G̐ƃQ[NAV[ړ
			enemy.setAliveFlag();
			if( enemy.getAliveFlag() == false )
			{
				gameScene = 9999;
			}

			//vC̐ƃQ[I[o[V[ړ
			player.setAliveFlag();
			if( player.getAliveFlag() == false )
			{
				gameScene = -9999;
			}

			//`XV
			lifThrow.drawLiftBlock();
			lifThrow.drawThrowBlock();
			field.drawBlock();
			enemy.drawEnemy();
			enemyAttack.drawBullet();
			player.drawPlayer();


			//C^[tF[X`
			draw.removeScene(&scene);
			draw.drawTime( int(timer.getTime()*100), &scene);

			draw.drawLife( player.getHPrate(), enemy.getHPrate(), &scene);

			draw.drawCombo( player.getComboNum(), &scene);

			//yĐ
			if(sound.getPlayStageBGM() == true )
			{
				sound.playStageBGM();
				if(window.getKeyStatus('M', false) & !prevMusic)
				{
					sound.stopStageBGM();
				}
			}
			else
			{
				if(window.getKeyStatus('M', false) & !prevMusic)
				{
					sound.playStageBGM();
				}
			}
			prevMusic = window.getKeyStatus('M', false);

		}
		/*
		//Q[NAV[
		*/
		else if(gameScene == 9999)
		{
			draw.removeScene(&scene);
			draw.drawGameClear(int(timer.getTime()*100), &scene);

			count ++;

			if(count > 180)
			{
				//낢돉
				camera.initCamera();						//J
				draw.initDraw();							//`揉
				enemy.initEnemy();							//G
				enemyAttack.initEnemyAttack();				//G̍U
				enemyAttack.initBulletPos(enemy.getPos());	//G̍Uʒu
				field.initField();							//tB[h
				lifThrow.initLifThrow();					//tX[
				player.initPlayer();						//vC[
				timer.initTimer();							//^C}[
				sound.initSound();							//TEh

				gameScene = 0;	//^Cgֈړ
				count = 0;
			}
		}
		/*
		//Q[I[o[V[
		*/
		else if(gameScene == -9999)
		{
			draw.removeScene(&scene);
			draw.drawGameOver(&scene);

			count ++;

			if(count > 180)
			{
				//낢돉
				camera.initCamera();						//J
				draw.initDraw();							//`揉
				enemy.initEnemy();							//G
				enemyAttack.initEnemyAttack();				//G̍U
				enemyAttack.initBulletPos(enemy.getPos());	//G̍Uʒu
				field.initField();							//tB[h
				lifThrow.initLifThrow();					//tX[
				player.initPlayer();						//vC[
				timer.initTimer();							//^C}[
				sound.initSound();							//TEh
			
				gameScene = 0;	//^Cgֈړ
				count = 0;
			}
		}

		
		//fobOp֐Ƃ
		//printf("%lf\n", time );
		//field.debug();
		//lifThrow.debug();
		//enemy.debug();
		//enemyAttack.debug();
		//sound.debug();
		//player.debug();
		//camera.debug();
		//draw.debug();
		//timer.debug();
	}

	return 0;
}
