#pragma once
#include "common.h"

class CAnima{
private:
	fk_Block		anima;
	fk_Model		animaModel;
	fkut_OBB		animaOBB;

	fk_Block		throwBlock;
	fk_Model		throwBlockModel;
	fkut_OBB		throwBlockOBB;

	CMotionCharactor		animaThrowObj;

	bool liveFlag; //Aj}݂Ă邩ǂ
	int	 actionType;	//Aj}ANV̎
	
	int throwLV;	//Aj}X[̃x
	int	countToBoot; //Aj}ANV܂ł̎
	int nowCount;	//Aj}X[ɏ݂̎

	int throwBlockDistance;	//Aj}X[̃ubN̈ړ

	bool blockFlag;	//Aj}X[ubN݂Ă邩ǂ
	bool throwFlag;	//Aj}X[ubNX[Ă邩ǂ

	int attackDamage;	//Aj}X[̃_[Wl

	fk_Vector animaSpd;
	fk_Vector animaThrowBlockSpd;

public:
	CAnima(void);
	~CAnima(void);

	void entryAnima(fk_Scene *argScene); //Aj}̃Gg[ƃ[u
	void entryAnimaThrowBlock(fk_Scene *argScene); //Aj}X[ubÑGg[ƃ[u

	fk_Vector	getPos();	//ʒu擾
	fk_Vector   getVec();	//擾
	fkut_OBB	getOBB();	//OBB擾

	void summonAnima(fk_Vector pos);	//Aj}̏
	void setActionType(int num);		//Aj}ANV̎ސݒ

	void setAnimaThrow(fk_Scene *argScene);	//Aj}X[̐ݒ
	void bootAnimaThrow(fk_Vector pos);	//Aj}X[̔
	void setAnimaVec(fk_Vector pos);	//Aj}̌̐ݒ
	void decCountToBoot(); //Aj}݂ꍇAAj}X[܂ł̎Ԃ̏
	void procAnimaThrow();	//Aj}X[̌o߁iubN̈ړj
	void setAnimaThrowBlock(bool isHit, fk_Scene *argScene);	//Aj}X[ubN̍Ĕzu

	void setAnimaRepair();	//Aj}yA̐ݒ
	void bootAnimaRepair();	//Aj}yA̔

	bool getLiveFlag();	//Aj}̑݃tO擾
	int  getActionType();	//Aj}ANV̎ޒl擾

	fk_Vector * getPSpd();	//ubN̉x̃AhX擾
	fk_Vector * getAnimaThrowBlockSpdAddress();	//ubN̉x̃AhX擾
	double getAttackDamage(double comboBonus);	//_[Wl̏

	bool checkCollision(fkut_OBB &hitOBB, fk_Vector *spd);

	void updateAnimaThrowObj();

};