#pragma once
#include "common.h"

class CEnemyAttack {
private:
	static const int bulletNum = 18;//Ge̍ő吔

	fk_Block		bullet[bulletNum];		
	fk_Model		bulletModel[bulletNum];

	fkut_OBB		bulletObb[bulletNum];

	CMotionCharactor		shockWaveObj[bulletNum];
	CMotionCharactor		shockWave_wObj[bulletNum];

	bool isEnemyAlive;	//GĂ邩ǂ

	bool isHitBullet[bulletNum];	//eɓ蔻肪邩ǂ
	bool isMoveBullet[bulletNum];	//eĂ邩ǂ
	int  bulletCount[bulletNum];	//e˂ẴJEg
	
	int AIcount;		//sAIJEg

	int debugNum;	//fobOp 

public:
	CEnemyAttack(fk_Vector pos);
	~CEnemyAttack(void);

	void entryScene(fk_Scene *argScene);
	void removeScene(fk_Scene *argScene);

	bool checkBulletCollision(fkut_OBB &playerOBB, fk_Vector *spd, fk_Vector pos); //vC[ƒeƂ̏Փˏ

	int  getBulletNum();	//Se̎擾

	void setEnemyAlive(bool isAlive);	//GĂ邩ǂ̒l̓

	void setBulletWideSize(fk_Scene *argScene);	//^ɓG̒ě`ύX
	void setBulletHeightSize(fk_Scene *argScene);	//c^ɓG̒ě`ύX
	void setBulletMultiSize( fk_Scene *argScene);	//^ɓG̒ě`ύX

	void setBulletVec(fk_Scene *argScene);	//ȇxA̐ݒ菈
	void moveBullet(fk_Vector pos);		//ëړ
	//void initBulletPos(int num ,fk_Vector pos);	//蔻̒ëʒȕ
	void initBulletPos(fk_Vector pos,  fk_Scene *argScene);	//蔻̒ëʒȕ

	void drawBullet();		//e̕`

	void choiceEnemyAI(int aiNum, fk_Scene *argScene);	//GAIp^[I

	void initEnemyAttack();	//G̍UNX̏ݒ̏

	void debugHitCheck();	//蔻fobOp
	void debug();	//fobOp
};
