#pragma once
#include "common.h"

class CKeyInput {
private:
	bool isGamePad;

	bool prevDOWN;
	bool prevLEFT;
	bool prevRIGHT;
	bool prevUP;
	bool prevJump;
	bool prevLift;
	bool prevThrow;
	bool prevAnima;
	bool prevAttack;
	bool prevMusic;
	bool prevPause;
	bool prevHelp;

	bool prevDebug;
	bool prevGaugeFull;
	bool prevQuarter;

	int animaActionType;

public:
	CKeyInput();
	~CKeyInput(void);

	void initAnimaActionType();	//Aj}ANV쏉
	int	 getAnimaActionType();	//Aj}ANV̒l擾

	bool getDOWNKeyStatus(fk_Window *window);
	bool getLEFTKeyStatus(fk_Window *window);
	bool getRIGHTKeyStatus(fk_Window *window);
	bool getUPKeyStatus(fk_Window *window);

	bool getJumpKeyStatus(fk_Window *window);
	bool getAttackKeyStatus(fk_Window *window);
	bool getLiftKeyStatus(fk_Window *window);	// (L[ɗƂɔƂ
	bool getThrowKeyStatus(fk_Window *window);
	bool getAnimaKeyStatus(fk_Window *window);

	bool getMusicKeyStatus(fk_Window *window);
	bool getPauseKeyStatus(fk_Window *window);
	bool getHelpKeyStatus(fk_Window *window);

	bool getDebugKeyStatus(fk_Window *window);
	bool getGaugeFullKeyStatus(fk_Window *window);
	bool getQuarterViewKeyStatus(fk_Window *window);

	void debug();
};