#pragma once
#include "common.h"

class CSound {
private:
	
	fk_AudioStream	titleBGM;
	fk_AudioStream	stageBGM;
	fk_AudioStream  rivalBGM;

	fk_AudioWavBuffer	jumpSE;
	fk_AudioWavBuffer	damageSE;
	fk_AudioWavBuffer	liftSE;
	fk_AudioWavBuffer	fallSE;

	fk_AudioWavBuffer	slashSE;
	fk_AudioWavBuffer	throwSE;

	bool	isPlayTitleBGM;
	bool	isPlayStageBGM;
	bool	isPlayRivalBGM;

	int	typeBGM;
	
public:
	CSound(void);
	~CSound(void);

	void playTitleBGM();	//^CgBGMĐ
	void stopTitleBGM();	//^CgBGM~
	bool getPlayTitleBGM(); //Xe[WBGMĐĂ邩ǂ擾

	void playStageBGM();	//Xe[WBGMĐ
	void stopStageBGM();	//Xe[WBGM~
	bool getPlayStageBGM(); //Xe[WBGMĐĂ邩ǂ擾

	void playRivalBGM();	//Xe[WBGMĐ
	void stopRivalBGM();	//Xe[WBGM~
	bool getPlayRivalBGM(); //Xe[WBGMĐĂ邩ǂ擾

	int getTypeBGM();	//ĐĂBGM̎ނ擾
	void changeTypeBGM();	//ĐĂBGM̎ނύX

	void playJumpSE();	//WvSEĐ
	void playDamageSE();	//_[WSEĐ
	void playLiftSE();	//ubNグSEĐ
	void playFallSE();	//SEĐ
	void playSlashSE();	//ߐڍUSEĐ
	void playThrowSE();	//SEĐ

	void initSound();	//TEhiS~

	void debug();				//fobOp
};