/*
//C֐
*/
#include "common.h"

#include "Field.h"
#include "LifThrow.h"
#include "Anima.h"

#include "Enemy.h"
#include "EnemyAttack.h"

#include "Sound.h"
#include "Camera.h"
#include "Player.h"
#include "Timer.h"
#include "Draw.h"

#include "KeyInput.h"

// enum^gĂ݂悤
enum Player_MotionStatus
{
	PLAYER_STOP = -1,
	PLAYER_STAND,		//0 ʏ헧
	PLAYER_WALK_F,		//1 siOj
	PLAYER_WALK_B,		//2 sij
	PLAYER_WALK_R,		//3 sij
	PLAYER_WALK_L,		//4 siEj
	PLAYER_JUMP,		//5 Wv
	PLAYER_SPIN,		//6 Wv_̉]
	PLAYER_FALL,		//7 
	PLAYER_ATTACK_NS,	//8 ߐڍUiXgbNȂj
	PLAYER_ATTACK_01,	//9 ߐڍUiXgbNj
	PLAYER_THROW,		//10 U
	PLAYER_DAMAGE		//11 _[W
};

enum InnocentEagle_MotionStatus
{
	INNOCENTEAGLE_STOP = -1,
	INNOCENTEAGLE_STAND, //0 _ij
	INNOCENTEAGLE_ACTION_THROW, //1 Aj}X[
	INNOCENTEAGLE_ACTION_REPAIR, //2 Aj}yA
};

enum RocKing_MotionStatus
{
	ROCKING_STOP = -1,
	ROCKING_STAND, //0 ʏ헧
	ROCKING_FALL_S,//1 U@Ռgp^[P
	ROCKING_FALL_L,//2 U@Ռgp^[Q
	ROCKING_FALL_F,//3 U@Ռgp^[R

};

int main(int argc, char *argv[])
{


	Fl_Window		mainWindow(WINDOW_WIDTH, WINDOW_HEIGHT, "LifThrow tX[I");
	fk_Model		lightModel; 
	fk_Light		light, spotlight;
	fk_Scene		scene;
	fk_Window		window(0, 0, WINDOW_WIDTH, WINDOW_HEIGHT);

	//^COo
	DWORD regTime = timeGetTime();


	CField			field;

	//^COo
	cout << "field ";
	cout << timeGetTime()-regTime << endl;
	regTime = timeGetTime();

	fkut_FrameController	fc;
	mainWindow.end();

	fk_InitMaterial();

	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.getMaterial()->setAmbDiff(1.0, 1.0, 1.0);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(0.5, -1.0, 0.0);


	//vC[p
	CPlayer			player;


	/*
	//vC[[VĐpNX̕ϐp
	*/
	CMotionCharactor	charaPlayer;

	// ^ZR̃f[^ǂݍ
	if(!charaPlayer.loadObjectData("nageru/nageru.mqo")) fl_alert("[nageru.mqo] Read Error.");
	// ZbgAbvf[^ǂݍ
	if(!charaPlayer.loadJointData("nageru/nageru_setup.fkc")) fl_alert("[nageru_setup.fkc] Read Error.");

	// [Vf[^ǂݍ݂ǂݍ
	if(!charaPlayer.loadMotionData("nageru/nageru_neutralpose.fkm")) fl_alert("[nageru_neutralpose.fkm] Read Error.");
	if(!charaPlayer.loadMotionData("nageru/nageru_walk_front.fkm")) fl_alert("[nageru_walk_front.fkm] Read Error.");
	if(!charaPlayer.loadMotionData("nageru/nageru_walk_back.fkm")) fl_alert("[nageru_walk_back.fkm] Read Error.");
	if(!charaPlayer.loadMotionData("nageru/nageru_walk_right.fkm")) fl_alert("[nageru_walk_right.fkm] Read Error.");
	if(!charaPlayer.loadMotionData("nageru/nageru_walk_left.fkm")) fl_alert("[nageru_walk_left.fkm] Read Error.");
	if(!charaPlayer.loadMotionData("nageru/nageru_jump_rize.fkm")) fl_alert("[nageru_jump_rize.fkm] Read Error.");
	if(!charaPlayer.loadMotionData("nageru/nageru_jump_spin.fkm")) fl_alert("[nageru_jump_spin.fkm] Read Error.");
	if(!charaPlayer.loadMotionData("nageru/nageru_jump_fall.fkm")) fl_alert("[nageru_jump_fall.fkm] Read Error.");
	if(!charaPlayer.loadMotionData("nageru/nageru_attack01.fkm")) fl_alert("[nageru_attack01.fkm] Read Error.");
	//{̓XgbNȂŨ[Vǂݍ݂AǂݍݑfނƂăXgbNo[W
	if(!charaPlayer.loadMotionData("nageru/nageru_attack01.fkm")) fl_alert("[nageru_attack01.fkm] Read Error.");
	if(!charaPlayer.loadMotionData("nageru/nageru_throw.fkm")) fl_alert("[nageru_throw.fkm] Read Error.");
	if(!charaPlayer.loadMotionData("nageru/nageru_damage.fkm")) fl_alert("[nageru_damage.fkm] Read Error.");

	// [Vp̕ϐ(gpȂ̂ŕK{ł͂Ȃ)
	Player_MotionStatus motionID = PLAYER_STAND;

	/*
	//vC[fA[V]X܂
	*/

	//^COo
	cout << "playerModel &playerMotion ";
	cout << timeGetTime()-regTime << endl;
	regTime = timeGetTime();

	/*
	//Aj}iCmZgC[Oj[VĐpNX̕ϐp
	*/
	CMotionCharactor	charaInnocentEagle;

	// ^ZR̃f[^ǂݍ
	if(!charaInnocentEagle.loadObjectData("anima/anima.mqo")) fl_alert("[anima.mqo] Read Error.");
	// ZbgAbvf[^ǂݍ
	if(!charaInnocentEagle.loadJointData("anima/anima_born.fkc")) fl_alert("[anima_born.fkc] Read Error.");

	// [Vf[^ǂݍ݂ǂݍ
	if(!charaInnocentEagle.loadMotionData("anima/init.fkm")) fl_alert("[init.fkm] Read Error.");
	if(!charaInnocentEagle.loadMotionData("anima/a_throw.fkm")) fl_alert("[a_throw.fkm] Read Error.");
	if(!charaInnocentEagle.loadMotionData("anima/metarika.fkm")) fl_alert("[metarika.fkm] Read Error.");

	// [Vp̕ϐ(gpȂ̂ŕK{ł͂Ȃ)
	InnocentEagle_MotionStatus ino_motionID = INNOCENTEAGLE_STOP;

	/*
	//Aj}iCmZgC[OjfA[V]X܂
	*/

	//^COo
	cout << "InnocentEagleModel &InnocentEagleMotion ";
	cout << timeGetTime()-regTime << endl;
	regTime = timeGetTime();

	/*
	//bNLO[VĐpNX̕ϐp
	*/
	CMotionCharactor	charaRocKing;

	// ^ZR̃f[^ǂݍ
	if(!charaRocKing.loadObjectData("rocking/RocKing_third.mqo")) fl_alert("[RocKing.mqo] Read Error.");
	// ZbgAbvf[^ǂݍ
	if(!charaRocKing.loadJointData("rocking/rocking.fkc")) fl_alert("[rocking.fkc] Read Error.");

	// [Vf[^ǂݍ݂ǂݍ
	if(!charaRocKing.loadMotionData("rocking/rocking_neutralpose.fkm")) fl_alert("[rocking_neutralpose.fkm] Read Error.");
	if(!charaRocKing.loadMotionData("rocking/rocking_jojo01.fkm")) fl_alert("[rocking_jojo01.fkm] Read Error.");
	if(!charaRocKing.loadMotionData("rocking/rocking_jojo01_roop.fkm")) fl_alert("[rocking_jojo01_roop.fkm] Read Error.");
	if(!charaRocKing.loadMotionData("rocking/rocking_jojo01_back.fkm")) fl_alert("[rocking_jojo01_back.fkm] Read Error.");

	// [Vp̕ϐ(gpȂ̂ŕK{ł͂Ȃ)
	RocKing_MotionStatus roc_motionID = ROCKING_STAND;

	/*
	//bNLOfA[V]X܂
	*/

	//^COo
	cout << "rockkingModel &rockkingMotion ";
	cout << timeGetTime()-regTime << endl;
	regTime = timeGetTime();

	//ubNグAp
	CLifThrow		lifThrow(player.getPos());

	//^COo
	cout << "lifThrow ";
	cout << timeGetTime()-regTime << endl;
	regTime = timeGetTime();

	//Aj}
	CAnima			anima;

	//Gp
	CEnemy			enemy;
	CEnemyAttack	enemyAttack(enemy.getPos() );

	//yp
	CSound			sound;


	//Jp
	CCamera			camera(enemy.getPos() );

	//^C}[p
	CTimer			timer;

	//͗p
	CKeyInput			input;

	//^COo
	cout << "sound ";
	cout << timeGetTime()-regTime << endl;
	regTime = timeGetTime();


	//C^[tFCX`p
	CDraw			draw;

	//^COo
	cout << "draw ";
	cout << timeGetTime()-regTime << endl;
	regTime = timeGetTime();

	// effBXvCXgɓo^
	scene.entryCamera(camera.getCameraModelAddress());
	scene.entryModel(&lightModel);
	scene.setBlendStatus(true);

	draw.entryScene(&scene, &window);	
	//^COo
	cout << "sceneEntry ";
	cout << timeGetTime()-regTime << endl;
	cout << "/////////////////////" << endl;


	// EBhEփfBXvCXgo^
	window.setScene(&scene);

	mainWindow.show();
	window.show();


	//V[؂ւ
	int gameScene = 0;

	//J[\؂ւ
	int cursolNum = 0;

	/*
	//[v
	*/
	while(true) {


		fc.TimeRegular();

		if(mainWindow.visible() == 0) 
		{
			if(Fl::wait() == 0)
			{
				break;
			}
			else
			{
				continue;
			}
		}

		if(fc.GetDrawFlag()) window.drawWindow();
		if(Fl::check() == 0) break;
		if(window.winOpenStatus() == false) continue;

		/*
		//^CgV[
		*/
		if( gameScene == 0)
		{
			//L[
			if( input.getUPKeyStatus(&window) )	cursolNum --;				
			//L[
			if( input.getDOWNKeyStatus(&window) )	cursolNum ++;
			//L[
			if( input.getLEFTKeyStatus(&window) )	cursolNum --;
			//EL[
			if( input.getRIGHTKeyStatus(&window) )	cursolNum ++;

			if( cursolNum < 0)
			{
				cursolNum = 1;
			}
			if( cursolNum > 1)
			{
				cursolNum = 0;
			}

			if(window.getKeyStatus('Z', false))
			{
				if( cursolNum == 0)
				{
					gameScene = 1;
					player.entryScene(&scene);
					field.entryScene(&scene);
					lifThrow.entryScene(&scene);
					enemy.entryScene(&scene);
					enemyAttack.entryScene(&scene);
					charaPlayer.entryScene(&scene);
					charaRocKing.entryScene(&scene);
					charaInnocentEagle.entryScene(&scene);
				}
				else/* if(cursolNum == 1 )*/
				{
					return 0;
				}
			}

			//yĐ
			if(sound.getPlayTitleBGM() == true )
			{
				sound.playTitleBGM();
				if(input.getMusicKeyStatus(&window))
				{
					sound.stopTitleBGM();
				}
			}
			else
			{
				if(input.getMusicKeyStatus(&window))
				{
					sound.playTitleBGM();
				}
			}

			draw.removeScene(&scene);
			draw.drawTitle(cursolNum, &scene);
		}
		/*
		//CQ[V[
		*/
		else if( gameScene == 1)
		{
			//fobO[h
			if(input.getDebugKeyStatus(&window))
			{
				player.debugHitCheck();
				enemy.debugHitCheck();
				enemyAttack.debugHitCheck();
				field.debugHitCheck();
			}
			if(input.getQuarterViewKeyStatus(&window))
			{
				camera.debugChangeMode();
			}
			if(input.getGaugeFullKeyStatus(&window))
			{
				player.debugGaugeFull();	
			}

			//Aj}L[l
			input.initAnimaActionType();
			//Aj}L[ςȂŃAj}쏀
			if(input.getAnimaKeyStatus(&window) ){}


			// J XZ Ƃɐis
			player.setView(camera.getCameraVec());

			// n㎞͓x^A󒆂ł͉x
			player.initSpd();

			//[V
			if( motionID != PLAYER_JUMP  && motionID != PLAYER_FALL && motionID != PLAYER_SPIN &&
				motionID != PLAYER_ATTACK_01 && motionID != PLAYER_THROW )
			{
				motionID = PLAYER_STAND;
			}

			//sړ
			if(player.getIsCanMove() == true && player.getIsAttack() == 0 )//sړ\ǂ
			{
				//ꂼꉺFQAFSAEFUAFWɂƂ@ieL[Ql
				if(window.getSpecialKeyStatus(FK_DOWN, false)) 	
				{
					player.moveAction(2); 
					if( motionID != PLAYER_JUMP  && motionID != PLAYER_FALL && motionID != PLAYER_SPIN &&
						motionID != PLAYER_ATTACK_01 && motionID != PLAYER_THROW )
					{
						motionID = PLAYER_WALK_B;
					}
				}
				if(window.getSpecialKeyStatus(FK_LEFT, false))
				{
					player.moveAction(4); 
					if( motionID != PLAYER_JUMP  && motionID != PLAYER_FALL && motionID != PLAYER_SPIN &&
						motionID != PLAYER_ATTACK_01 && motionID != PLAYER_THROW )
					{
						motionID = PLAYER_WALK_L;
					}
				}
				if(window.getSpecialKeyStatus(FK_RIGHT, false)) 
				{
					player.moveAction(6);
					if( motionID != PLAYER_JUMP  && motionID != PLAYER_FALL && motionID != PLAYER_SPIN &&
						motionID != PLAYER_ATTACK_01 && motionID != PLAYER_THROW )
					{
						motionID = PLAYER_WALK_R;
					}
				}
				if(window.getSpecialKeyStatus(FK_UP, false))
				{
					player.moveAction(8);
					if( motionID != PLAYER_JUMP  && motionID != PLAYER_FALL && motionID != PLAYER_SPIN &&
						motionID != PLAYER_ATTACK_01 && motionID != PLAYER_THROW )
					{
						motionID = PLAYER_WALK_F;
					}
				}
			}
			player.normSpd();//ŌݒɍsĂiۂ̕ύX͈ړ̏ŕsčs

			// Wv̏x XZ ̊x悹
			if(input.getJumpKeyStatus(&window))
			{
				if(player.setResaState(false) == true )
				{
					player.setResaState(true);
				}
				if(	player.getIsJump() == false && player.getIsCanMove() == true)//Wv\ǂ̔
				{

					if(input.getAnimaActionType() < 10 )
					{
						if(player.setResaState(false) == false )
						{
							player.jumpAction(false);
							sound.playJumpSE();

							motionID = PLAYER_JUMP;
						}
						/*else{
							player.setResaState(true);
						}*/
					}
				}
			}

			// d͉x
			if(player.setResaState(false) == false )
			{
				player.setGravity();
			}

			if(player.getIsAttack() != 0 )
			{
				player.moveAttack();
			}

			// x𑬓xɏ悹
			player.addAcc();

			//ubÑ_bV
			player.dashAction();

			//vC[ƃtB[h̃ubNƂ̏Փ˔Ăяo
			if(field.checkCollisionToPlayer(player.getOBB(), player.getPSpd() ) )
			{
				player.initAcc();
				if(motionID == PLAYER_JUMP || motionID == PLAYER_SPIN || motionID == PLAYER_FALL)
				{
					motionID = PLAYER_STOP;
				}
			}

			//vC[ƓGƂ̏Փ˔
			if( player.getDamageState() == false )
			{
				if(enemy.checkCollisionToPlayer(player.getOBB(), player.getPSpd()))
				{
					if(enemy.getIsDamageBody() == true )
					{
						player.setDamageState(1);//vC[ւ̃_[Wi̓_[W
						sound.playDamageSE();
					}
				}
			}

			//vC[ƓGeƂ̏Փ˔
			if( player.getDamageState() == false )
			{
				if(enemyAttack.checkBulletCollision(player.getOBB(), player.getPSpd(), enemy.getPos() ))
				{
					player.setDamageState(1);//vC[ւ̃_[Wi̓_[W
					sound.playDamageSE();
				}
			}			

			if(player.getDamageState() == true )
			{
				motionID = PLAYER_DAMAGE;
			}

			enemyAttack.initBulletPos(enemy.getPos(), &scene);

			//vC[f̈ړ
			player.translatePlayer();
			player.moveShadow();
			// + G̕փvČ̕ύX
			player.setVecEnemy(enemy.getPos());


			if(	player.setFallState())
			{
				player.setDamageState(1);
			}


			//[Vf[^̌ύX
			charaPlayer.getBaseModel()->glVec(player.getPlayerVec());

			//[Vf[^̈ړ
			charaPlayer.getBaseModel()->glMoveTo(player.getPos().x, player.getPos().y-22.5, player.getPos().z);


			//グubN̈ʒuꏏɈړ
			lifThrow.setLiftBlockPos(player.getPos());
			lifThrow.rotationLiftBlock();


			//Jړ
			camera.moveCameraPos(player.getPos(), player.getPlayerVec(), enemy.getPos() );
			camera.moveCameraFocus(enemy.getPos() );



			//͂ݏ
			if(player.getIsCanMove() == true )	//\ǂ̔
			{
				if(input.getLiftKeyStatus(&window))
				{
					if(input.getAnimaActionType() < 10 )
					{
						if(lifThrow.getLiftBlockCount() < 6 ) //ĂubN̐UȂ
						{
							if( field.getJudgeCatch(-1) != 0 ) //グ\ǂ
							{
								lifThrow.setLiftBlockNum(&scene);
								field.setBlockCatch(&scene);
								//Wv
								player.jumpAction(true);

								sound.playLiftSE();
								motionID = PLAYER_JUMP;
							}
						}
					}
				}
			}		

			//ubN̉x
			lifThrow.setThrowVector();
			//ubN̏
			lifThrow.setThrowBlockFlag(&scene);

			//Uf̕
			if(player.getIsAttack() == 0)//UĂȂ␳
			{
				player.setAttackVec(player.getPlayerVec());
			}
			//ߐڍU
			player.attackAction();
			if( timer.getTime()*100 > 1.0)//Q[JnɂߐڍUĂ܂Ȃ悤ɂb菈
			{
				if(input.getAttackKeyStatus(&window))
				{
					if(input.getAnimaActionType() < 10 )
					{
						if( lifThrow.getLiftBlockCount() > 0 ) //グĂubN̐PȏȂ
						{

							//XgbNUԂ
							player.setAttack();
							lifThrow.decLiftBlock(&scene);
							motionID = PLAYER_ATTACK_01;
						}
						else
						{
							//XgbNȂUԂ
							motionID = PLAYER_ATTACK_NS;
						}
					}
				}
			}

			//꓊

			if(input.getThrowKeyStatus(&window))
			{
				if(input.getAnimaActionType() < 10 )
				{
					if( lifThrow.getLiftBlockCount() > 0 ) //グĂubN̐PȏȂ
					{		
						//ubNu
						lifThrow.setThrowAngle(enemy.getPos(), &scene );

						//_bVԂ
						player.setIsDash();
						sound.playThrowSE();

						motionID = PLAYER_THROW;
						charaPlayer.stillMotion(motionID, 0);
						charaPlayer.setNowFrame(motionID, 0);
						charaPlayer.playMotion(motionID);
					}
				}
			}

			//Aj}ANV
			if(player.getAnimaGauge() >= 1.0 )
			{
				//Aj}XbV
				if(input.getAnimaActionType() == 11 )
				{
				}
				//Aj}X[
				if(input.getAnimaActionType() == 12 )
				{
					anima.summonAnima(player.getPos() );
					anima.setAnimaThrow(&scene);
					anima.setActionType( 2 );
					//lifThrow.summonAnima(&scene);
					player.useAnimaGauge();
					ino_motionID = INNOCENTEAGLE_ACTION_THROW;
					charaInnocentEagle.entryScene(&scene);
				}
				//Aj}yA
				if(input.getAnimaActionType() == 13 )
				{
					anima.summonAnima(player.getPos() );
					anima.setAnimaRepair();
					anima.setActionType( 3 );
					field.repairBlock(&scene);
					player.useAnimaGauge();
					ino_motionID = INNOCENTEAGLE_ACTION_REPAIR;
					charaInnocentEagle.entryScene(&scene);
				}
				//Aj}uCN
				if(input.getAnimaActionType() == 14 )
				{
				}
			}

			player.procAnimaGauge();		//Aj}Q[W
			anima.decCountToBoot();		//삵ĂAj}ANV܂ł̎
			switch(anima.getActionType() )
			{
			case 1:
				break;

				//Aj}X[
			case 2:
				anima.bootAnimaThrow(enemy.getPos());	//Aj}X[̐ݒ
				anima.procAnimaThrow();					//Aj}X[̐is
				anima.setAnimaThrowBlock(false, &scene);	//Aj}X[̃ubN̐ݒ
				break;

				//Aj}yA
			case 3:
				anima.bootAnimaRepair();

			}
			anima.setAnimaVec(enemy.getPos());	//Aj}̌C
			anima.entryAnima(&scene);			//Aj}̃Gg[A[u
			anima.entryAnimaThrowBlock(&scene);	//Aj}X[ubÑGg[A[u


			//Aj}iCmZgC[OjF[Vf[^̌ύX
			charaInnocentEagle.getBaseModel()->glVec(anima.getVec());

			//Aj}iCmZgC[OjF[Vf[^̈ړ
			charaInnocentEagle.getBaseModel()->glMoveTo(anima.getPos().x, anima.getPos().y-5.0, anima.getPos().z);

			//Aj}iCmZgC[Ojf̃Gg[E[u
			if(anima.getLiveFlag() == false )
			{
				charaInnocentEagle.removeScene(&scene);
			}

			// GƓubN̏Փ˔Ăяo
			//enemyɏՓ˔菈݂AforœubŇiUj񂵂Ƃ
			//ȂŌ̏(throwObb[5]jtȂlifThrowŔ
			for(int i = 0; i < 6; i++ )
			{
				if(lifThrow.checkCollision(i, enemy.getEnemyObb(), lifThrow.getThrowBlockSpdAddress(), &scene ) == true )
				{
					enemy.damageEnemy(lifThrow.getAttackDamage(player.getComboBonus() ) );//Gւ̃_[Wi̓_[W
					player.addLifThrowCombo();	//R{
				}
			}

			if(anima.checkCollision(enemy.getEnemyObb(), anima.getAnimaThrowBlockSpdAddress()))
			{
				enemy.damageEnemy(anima.getAttackDamage(player.getComboBonus() ) );//Gւ̃_[Wi̓_[W
				player.addLifThrowCombo();	//R{
			}

			player.setCombo();


			//GƋߐڍȔՓ˔Ăяo
			if(player.checkAttackCollision(enemy.getEnemyObb(), lifThrow.getThrowBlockSpdAddress() ) == true )
			{
				enemy.damageEnemy(player.getAttackDamage() );//Gւ̃_[Wi̓_[W

				sound.playSlashSE();
			}

			enemy.setAliveFlag();	//GĂ邩̔
			enemy.setDamageState();	//G̐H炢[VI
			//enemy.setInv();	//Gւ̖GԂ̐ݒ

			//G̍s
			enemyAttack.setEnemyAlive(enemy.getAliveFlag());

			if(	field.checkCollisionToEnemy(enemy.getEnemyObb(), enemy.getPSpd()) )
			{
				enemy.judgeHitToBlock();
			}

			enemy.plusAICount();
			enemy.actAI();
			enemy.moveShadow();
			enemy.initHitFlagToBlock();
			enemy.focusToPlayer(player.getPos());


			if(enemy.getAliveFlag() == true)
			{
				enemyAttack.choiceEnemyAI(enemy.getAIPattern(), &scene);
				enemyAttack.moveBullet(enemy.getPos());
			}						

			//bNLOF[Vf[^̌ύX
			charaRocKing.getBaseModel()->glVec(enemy.getVec());

			//bNLOF[Vf[^̈ړ
			charaRocKing.getBaseModel()->glMoveTo(enemy.getPos().x, enemy.getPos().y-60.0, enemy.getPos().z);

			//bNLÕ[V]X
			if(enemy.getAIPattern() == 2 )
			{
				roc_motionID = ROCKING_FALL_S;
			}
			else if(enemy.getAIPattern() == 3 )
			{
				roc_motionID = ROCKING_FALL_L;
			}
			else if(enemy.getAIPattern() > 3 && enemy.getAIPattern() < 6 )
			{
				roc_motionID = ROCKING_FALL_F;
			}			

			//vC[̃[V]X
			if(motionID == PLAYER_JUMP && player.getSpd().y < 1.0 && motionID != PLAYER_ATTACK_01 && motionID != PLAYER_THROW)
			{
				motionID = PLAYER_SPIN;
			}

			if(player.getSpd().y < -0.1 && motionID != PLAYER_ATTACK_01 && motionID != PLAYER_THROW )
			{
				motionID = PLAYER_FALL;
			}

			// [v1񂲂Ƃ playMotion(Đԍ) ĂԂ1t[[Vi
			// Đԍ loadMotionData() œǂݍ񂾏(0X^[g)
			//iQ̃[V
			switch(motionID) {
			case PLAYER_STAND:	// <-R(:)łBZ~R(;)ȂI
			case PLAYER_WALK_F:// ƌĂёƌJԂĐ
			case PLAYER_WALK_B:
			case PLAYER_WALK_R:
			case PLAYER_WALK_L:
			case PLAYER_JUMP:
			case PLAYER_FALL:
			case PLAYER_DAMAGE:
				charaPlayer.playMotion(motionID);
				break;
			case PLAYER_SPIN:
			case PLAYER_THROW:
			case PLAYER_ATTACK_NS:
			case PLAYER_ATTACK_01:// breaktɎcase΁Acaseŋʂ̏
				// 1񂫂̍ĐŎ~߂ꍇ́AIođΏ
				if(charaPlayer.isMotionFinished(motionID) == true) {
					charaPlayer.setNowFrame(motionID, 0);
					motionID = PLAYER_STOP;

				} else {
					charaPlayer.playMotion(motionID);
				}
				break;

			default:	// ܂łŏcaseɓĂ͂܂Ȃꍇ̏
				break;
			}

			//Aj}iCmZgC[Oj̃[V
			switch(ino_motionID) {
				case INNOCENTEAGLE_STAND:
					charaInnocentEagle.playMotion(ino_motionID);
					break;
				case INNOCENTEAGLE_ACTION_THROW:
				case INNOCENTEAGLE_ACTION_REPAIR:
					// 1񂫂̍ĐŎ~߂ꍇ́AIođΏ
					if(charaInnocentEagle.isMotionFinished(ino_motionID) == true) {
						charaInnocentEagle.setNowFrame(ino_motionID, 0);
						ino_motionID = INNOCENTEAGLE_STAND;
					} 
					else 
					{
						charaInnocentEagle.playMotion(ino_motionID);
					}
					break;

				default:
					break;
			}

			//bNLÕ[V
			switch(roc_motionID) {
			case ROCKING_STAND:
			case ROCKING_FALL_L:
			case ROCKING_FALL_S:			
				charaRocKing.playMotion(roc_motionID);
				break;

			case ROCKING_FALL_F:		
				// 1񂫂̍ĐŎ~߂ꍇ́AIođΏ
				if(charaRocKing.isMotionFinished(roc_motionID) == true) {
					charaRocKing.setNowFrame(roc_motionID, 0);
					roc_motionID = ROCKING_STAND;
				} 
				else 
				{
					charaRocKing.playMotion(roc_motionID);
				}
				break;

			default:
				break;
			}


			//wv\̃IIt
			if(input.getHelpKeyStatus(&window))
			{
				draw.switchHelp();
			}

			//ԍXV
			if(enemy.getAliveFlag() == true)
			{
				timer.addTime(0.0166666667);
			}

			//G̐ƃQ[NAV[ړ
			enemy.setAliveFlag();
			if( enemy.getAliveFlag() == false )
			{
				gameScene = 9999;
			}

			//vC̐ƃQ[I[o[V[ړ
			player.setAliveFlag();
			if( player.getAliveFlag() == false )
			{
				gameScene = -9999;
			}


			//`XV
			lifThrow.drawLiftBlock();
			lifThrow.drawThrowBlock();
			field.drawBlock();
			enemy.drawEnemy();
			enemyAttack.drawBullet();
			player.drawPlayer();

			field.drawBlockObj();
			lifThrow.drawBlockObj();
		
			field.updateBlockObj(&scene);
		

			//C^[tF[X`
			draw.removeScene(&scene);

			draw.drawCharacterIcon( &scene);
			draw.drawLife( player.getHPrate(), enemy.getHPrate(), &scene);
			draw.drawStockGauge( lifThrow.getLiftBlockCount(), 0, &scene );
			draw.drawAnimaGauge( player.getAnimaGauge(), 0, &scene );
			//draw.drawScore( 12345678, 0, &scene );
			draw.drawTime( int(timer.getTime()*100), &scene);
			draw.drawCombo( player.getComboNum(), &scene);
			draw.drawHelp(&scene);

			//yĐ
			if(input.getMusicKeyStatus(&window))
			{
				sound.stopTitleBGM();
				sound.stopStageBGM();
				sound.stopRivalBGM();
				sound.changeTypeBGM();
			}

			switch(sound.getTypeBGM())
			{
			case 0:
				sound.playTitleBGM();
				break;

			case 1:
				sound.playStageBGM();
				break;

			case 2:
				sound.playRivalBGM();
				break;

			case 3:
				break;

			default:
				break;
			}


			//|[Y
			if(input.getPauseKeyStatus(&window))
			{
				gameScene = -999;
			}
		}
		/*
		//|[Y
		*/
		else if(gameScene == -999)
		{
			if(input.getPauseKeyStatus(&window))
			{
				gameScene = 1;
			}
			draw.drawPause(&scene);
		}
		/*
		//Q[NAV[
		*/
		else if(gameScene == 9999)
		{
			draw.removeScene(&scene);
			draw.drawGameClear(int(timer.getTime()*100), &scene);

			if(window.getSpecialKeyStatus(FK_ENTER, true))
			{
				//낢돉
				draw.initDraw();							//`揉
				enemy.initEnemy();							//G
				enemyAttack.initEnemyAttack();				//G̍U
				enemyAttack.initBulletPos(enemy.getPos(), &scene);	//G̍Uʒu
				camera.initCamera(enemy.getPos());			//J
				field.initField();							//tB[h
				lifThrow.initLifThrow();					//tX[
				player.initPlayer();						//vC[
				timer.initTimer();							//^C}[
				sound.initSound();							//TEh

				motionID = PLAYER_STAND;
				ino_motionID = INNOCENTEAGLE_STAND;
				roc_motionID = ROCKING_STAND;

				gameScene = 0;	//^Cgֈړ
			}
		}
		/*
		//Q[I[o[V[
		*/
		else if(gameScene == -9999)
		{
			draw.removeScene(&scene);
			draw.drawGameOver(&scene);

			if(window.getSpecialKeyStatus(FK_ENTER, true))
			{
				//낢돉
				draw.initDraw();							//`揉
				enemy.initEnemy();							//G
				enemyAttack.initEnemyAttack();				//G̍U
				enemyAttack.initBulletPos(enemy.getPos(), &scene);	//G̍Uʒu
				camera.initCamera(enemy.getPos());			//J
				field.initField();							//tB[h
				lifThrow.initLifThrow();					//tX[
				player.initPlayer();						//vC[
				timer.initTimer();							//^C}[
				sound.initSound();							//TEh

				motionID = PLAYER_STAND;
				ino_motionID = INNOCENTEAGLE_STAND;
				roc_motionID = ROCKING_STAND;

				gameScene = 0;	//^Cgֈړ
			}


		}	

		/*
		//^COop̃ev
		/*
		DWORD regTime = timeGetTime();
		cout << timeGetTime()-regTime << endl;

		time = timeGetTime();
		window.printf( "%d" , timeGetTime()-time );
		*/

		//fobOp֐Ƃ
		//printf("%d\n", roc_motionID );
		//player.debug();
		//field.debug();
		///lifThrow.debug();
		//enemy.debug();
		//enemyAttack.debug();
		//sound.debug();
		//camera.debug();
		//draw.debug();
		//timer.debug();
		//input.debug();

	}

	return 0;
}
