#include "adventureBase.h"

CAdventureBase::CAdventureBase(void)
{

	sceneNum=-1;
	prevAdventure=false;
	adventureEnd=false;
	readBuffer.push_back("");


}

CAdventureBase::~CAdventureBase(void)
{
}



void CAdventureBase::remove(fk_Scene *scene)
{
	scene->removeOverlayModel(&charaLeft);
	scene->removeOverlayModel(&charaRight);
	scene->removeOverlayModel(&charaMiddle);
	scene->removeOverlayModel(&messageUp);

	scene->removeOverlayModel(&messageDown);
	scene->removeOverlayModel(&textDown);

	scene->removeOverlayModel(&textUp);
	scene->removeOverlayModel(&textDownName);

	scene->removeOverlayModel(&textUpName);
}

void CAdventureBase::init()
{

	if(charaNageru.readPNG("dat/graph/adventure/cw_nageru.png") == false) fl_alert("摜ǂݍݎs");
		if(charaIno.readPNG("dat/graph/adventure/cw_ino.png") == false) fl_alert("摜ǂݍݎs");
			if(charaBonta.readPNG("dat/graph/adventure/cw_bonta.png") == false) fl_alert("摜ǂݍݎs");
	if(charaRock.readPNG("dat/graph/adventure/cw_rockking.png") == false) fl_alert("摜ǂݍݎs");
	if(messageLight.readPNG("dat/graph/adventure/message1.png") == false) fl_alert("摜ǂݍݎs");
	if(messageDark.readPNG("dat/graph/adventure/message2.png") == false) fl_alert("摜ǂݍݎs");
	if(textDown.initFont("C:/WINDOWS/Fonts/Meiryo.ttc") == false) fl_alert("tHgǂݍݎs");
	if(textUp.initFont("C:/WINDOWS/Fonts/Meiryo.ttc") == false) fl_alert("tHgǂݍݎs");
	if(textDownName.initFont("C:/WINDOWS/Fonts/Meiryo.ttc") == false) fl_alert("tHgǂݍݎs");
	if(textUpName.initFont("C:/WINDOWS/Fonts/Meiryo.ttc") == false) fl_alert("tHgǂݍݎs");
	textDown.text.setPTSize(20);
	textUp.text.setPTSize(20);
	textDownName.text.setPTSize(16);
	textUpName.text.setPTSize(16);
	textDown.text.setAlign(FK_ALIGN_LEFT);
	textUp.text.setAlign(FK_ALIGN_LEFT);
	textDown.text.setSendingMode(FK_SENDING_CHAR);
	textUp.text.setSendingMode(FK_SENDING_CHAR);
	textDown.text.setShadowMode(true);
	textDown.text.setShadowOffset(-3,3);
	textUp.text.setShadowMode(true);
	textUp.text.setShadowOffset(-3,3);




	charaLeft.setPositionLT(-260,0);
	charaRight.setPositionLT(260,0);
	charaMiddle.setPositionLT(0,0);

	messageUp.setPositionLT(0,160);
	messageDown.setPositionLT(0,-160);
	
	


	this->readScenarioToArray();

}

void CAdventureBase::readScenario()
{
	textReading.clear();
	if(in_file.is_open() == false) {
		fl_alert("error");
	}else{
		getline(in_file, lineStr);
		splitArray = fk_StrSplit(lineStr, "/");
		for(int i = 0 ; i < (int)splitArray.size(); i++) {
			textReading=textReading+splitArray[i]+"\n";	
		}
	
		readBuffer.push_back(textReading);
		
	}
}

void CAdventureBase::readScenarioToArray()
{
	while(textReading!="[finish]\n"){
		this->readScenario();
	}
	return ;
	}



void CAdventureBase::end(fk_Scene *scene)
{
	textUp.drawText("",true);
	textDown.drawText("",true);
	textUpName.drawText("",true);
	textDownName.drawText("",true);
	this->remove(scene);
	adventureEnd=true;


}
