//---------------------------------------------------
// RtBO֌Wf[^x[X
//---------------------------------------------------

#include "configDB.h"

CConfigDB::CConfigDB()
{
	bgmVolume = 100 ;
	seVolume = 100 ;
	fullScreen = 0 ;
	highSpecMode = 0 ;
	cameraMode = 0 ;
}

CConfigDB::~CConfigDB()
{
}

/*
 RtBOt@Cǂݍ
 */
void CConfigDB::loadConfig( const char* pass )
{
	char			str[1024] ;
	unsigned int	equalPoint ;
	std::string		checkStr , numStr ;

	// t@CI[v
	std::ifstream txt( pass );
	if( txt.fail() )
	{
		fl_alert( "read error [%s]" , pass );
		return ;
	}
	while( !txt.eof() )
	{
		txt.getline( str , 1024 );
		txtStr.push_back( str );
	}
	txt.close();

	// f[^o^
	int size = txtStr.size();
	for( int i=0 ; i<size ; i++ )
	{
		if( ( equalPoint = txtStr[i].find( '=' , 0 ) ) != string::npos )
		{
			checkStr = txtStr[i].substr( 0 , equalPoint );
			numStr = txtStr[i].substr( equalPoint+1 );
			if( checkStr == "BGMVolume" )
			{
				bgmVolume = atoi( numStr.c_str() );
				if( bgmVolume < 0 || bgmVolume > 100 )
				{
					bgmVolume = 100 ;
				}
			}
			else if( checkStr == "SEVolume" )
			{
				seVolume = atoi( numStr.c_str() );
				if( seVolume < 0 || seVolume > 100 )
				{
					seVolume = 100 ;
				}
			}
			else if( checkStr == "FullScreen" )
			{
				fullScreen = atoi( numStr.c_str() );
				if( fullScreen < 0 || fullScreen > 1 )
				{
					fullScreen = 0 ;
				}
			}
			else if( checkStr == "HighSpecMode" )
			{
				highSpecMode = atoi( numStr.c_str() );
				if( highSpecMode < 0 || highSpecMode > 1 )
				{
					highSpecMode = 0 ;
				}
			}
			else if( checkStr == "CameraMode" )
			{
				cameraMode = atoi( numStr.c_str() );
				if( cameraMode < 0 || cameraMode > 1 )
				{
					cameraMode = 0 ;
				}
			}
		}
	}
	txtStr.clear();
}

/*
 RtBOt@C
 */
void CConfigDB::saveConfig( const char* pass )
{
	int		txtSize = 0 ;
	char	str[1024] ;

	txtStr.push_back( "[CONFIG]" );
	sprintf_s( str , 1024 , "BGMVolume=%d" , bgmVolume );
	txtStr.push_back( str );
	sprintf_s( str , 1024 , "SEVolume=%d" , seVolume );
	txtStr.push_back( str );
	sprintf_s( str , 1024 , "FullScreen=%d" , fullScreen );
	txtStr.push_back( str );
	sprintf_s( str , 1024 , "HighSpecMode=%d" , highSpecMode );
	txtStr.push_back( str );
	sprintf_s( str , 1024 , "CameraMode=%d" , cameraMode );
	txtStr.push_back( str );
	txtStr.push_back( "" );
	txtStr.push_back( "*BGMVolume:Q[BGM̉ʁB0`100B" );
	txtStr.push_back( "*SEVolume:Q[̌ʉ̉ʁB0`100B" );
	txtStr.push_back( "*FullScreen:0ŃEBhE[hA1ŃtXN[[hB" );
	txtStr.push_back( "*HighSpecMode:0ŒXybN[hA1ōXybN[hB" );
	txtStr.push_back( "*CameraMode:0ŃJA1ŃJ蓮B" );

	// t@CI[v
	std::ofstream	txt( pass );
	if( txt.fail() )
	{
		fl_alert( "read error [%s]" , pass );
		return ;
	}
	txtSize = txtStr.size();
	for( int i=0 ; i<txtSize ; i++ )
	{
		txt << txtStr[i] << std::endl ;
	}
	txt.close();

	txtStr.clear();
}

/*
 bgmVolumeݒ
 */
void CConfigDB::setBgmVolume( int num )
{
	if( num >= 0 && num <= 100 )
	{
		bgmVolume = num ;
	}
}

/*
 seVolumeݒ
 */
void CConfigDB::setSeVolume( int num )
{
	if( num >= 0 && num <= 100 )
	{
		seVolume = num ;
	}
}

/*
 fullScreenݒ
 */
void CConfigDB::setFullScreen( int num )
{
	if( num == 0 || num == 1 )
	{
		fullScreen = num ;
	}
}

/*
 highSpecModeݒ
 */
void CConfigDB::setHighSpecMode( int num )
{
	if( num == 0 || num == 1 )
	{
		highSpecMode = num ;
	}
}

/*
 cameraModeݒ
 */
void CConfigDB::setCameraMode( int num )
{
	if( num == 0 || num == 1 )
	{
		cameraMode = num ;
	}
}

/*
 bgmVolume擾
 */
int CConfigDB::getBgmVolume()
{
	return bgmVolume ;
}

/*
 seVolume擾
 */
int CConfigDB::getSeVolume()
{
	return seVolume ;
}

/*
 fullScreen擾
 */
int CConfigDB::getFullScreen()
{
	return fullScreen ;
}

/*
 highSpecMode擾
 */
int CConfigDB::getHighSpecMode()
{
	return highSpecMode ;
}

/*
 cameraMode擾
 */
int CConfigDB::getCameraMode()
{
	return cameraMode ;
}
