#include "effectAnimaRushHit.h"

CEffectAnimaRushHit::CEffectAnimaRushHit(void)
{
	for(int i=0;i<9;i++){
	RushT[i]=-1;
	}

	RushN=0;
	
	
}

CEffectAnimaRushHit::~CEffectAnimaRushHit(void)
{
	
}



void CEffectAnimaRushHit::effectSet(CDatabase *DB, fk_Model *Target)
{
	if(RushN>8){ 
		RushN=0;
	}
	effectPos=Target->getPosition();

	DB->effectDB.glMoveTo(this->setNum(RushN),(effectPos.x)+rand()%60-30,(effectPos.y)+rand()%60-30,(effectPos.z)-10);
	
	DB->effectDB.entryEffect(this->setNum(RushN));
	RushT[RushN]=30;


	RushN++;
}

void CEffectAnimaRushHit::update(CDatabase *DB)
{

	for(int i=0;i<9;i++){

		if(RushT[i]>0){
RushT[i]--;

		DB->effectDB.focusCamera(this->setNum(i) , DB->systemDB.getCamera() );
		DB->effectDB.setScale(this->setNum(i),0.9,0.9);
		
		}
		
		if(RushT[i]==0){
				DB->effectDB.setScale(this->setNum(i),1/pow(0.9,30),1/pow(0.9,30));

			this->effectDelete(DB,i);
			RushT[i]=-1;

		}
	}
	
}

void CEffectAnimaRushHit::effectDelete(CDatabase *DB,int a)
{
	DB->effectDB.glMoveTo(this->setNum(a),effectPos);
	
	DB->effectDB.removeEffect(this->setNum(a));

}

void CEffectAnimaRushHit::init(CDatabase *DB)
{
	for(int i=0;i<9;i++){
		DB->effectDB.createEffectBlack(this->setNum(i),  "dat/effect/galaxy125.png" , 1 , 1 );
	DB->effectDB.setSize( this->setNum(i) , 150.0 , 150.0 );

	DB->effectDB.setRendMode(this->setNum(i));
	DB->effectDB.focusCamera( this->setNum(i) , DB->systemDB.getCamera() );
	}


	
	
}


std::string CEffectAnimaRushHit::setNum(int a)
{
	std::string animaRushHitN="animaRushHit"+a;
 return animaRushHitN;
}
