//---------------------------------------------------
// GtFNg֌Wf[^x[X
//---------------------------------------------------

#pragma once

#include "common.h"
#include "FKT.h"

class CEffectDB
{
private:
	fk_Scene	*scene ;

	struct effectBase
	{
		fk_Model		*model ;
		fk_RectTexture	*texture ;
		fk_Material		*material ;
		int				Xnum , Ynum ;
		CFkt			*modelT;
	};

	std::map<std::string , effectBase*>				effect ;
	std::map<std::string , effectBase*>::iterator	effectIte ;

public:
	CEffectDB();
	~CEffectDB();



	void	setAddress( fk_Scene *s );
	void	createEffect( std::string name , std::string pass , int argXnum , int argYnum );
	void	createEffectBlack( std::string name , std::string pass , int argXnum , int argYnum );
	void	deleteEffect( std::string name );
	void	deleteEffectAll();
	bool	findEffect( std::string name );
	void	setFrame( std::string name , int frame );
	void	setSize( std::string name , double x , double y );
	void	setScale( std::string name , double x , double y );
	void	setAlpha( std::string name , double a );
	void	setParent( std::string name , fk_Model *model );
	void	deleteParent( std::string name );
	void	focusCamera( std::string name , fk_Model *camera );
	void	entryEffect( std::string name );
	void	removeEffect( std::string name );
	void	glMoveTo( std::string name , double x , double y , double z );
	void	glMoveTo( std::string name , fk_Vector v );
	void	glTranslate( std::string name , double x , double y , double z );
	void	glTranslate( std::string name , fk_Vector v );
	void	loTranslate( std::string name , double x , double y , double z );
	void	loTranslate( std::string name , fk_Vector v );
	void	glFocus( std::string name , double x , double y , double z );
	void	glFocus( std::string name , fk_Vector v );
	void	loFocus( std::string name , double x , double y , double z );
	void	loFocus( std::string name , fk_Vector v );
	void	setRendMode(std::string name);

};
