#include "effectRepair.h"

CEffectRepair::CEffectRepair(void)
{
	for(int i=0;i<10;i++){
	RepairT[i]=-1;
	}

	RepairN=0;
	
	effectMove.set(0,0.5,0);
}

CEffectRepair::~CEffectRepair(void)
{
	
}



void CEffectRepair::effectSet(CDatabase *DB, fk_Model *Target)
{
	if(RepairN>9){ 
		RepairN=0;
	}
	effectPos=Target->getPosition();

	DB->effectDB.glMoveTo(this->setNum(RepairN),effectPos);
	
	DB->effectDB.entryEffect(this->setNum(RepairN));
	RepairT[RepairN]=90;


	RepairN++;
}

void CEffectRepair::update(CDatabase *DB)
{

	for(int i=0;i<10;i++){

		if(RepairT[i]>0){
RepairT[i]--;

		DB->effectDB.focusCamera(this->setNum(i) , DB->systemDB.getCamera() );
		DB->effectDB.glTranslate(this->setNum(i), effectMove);
		
		}
		
		if(RepairT[i]==0){
			
			this->effectDelete(DB,i);
			RepairT[i]=-1;

		}
	}
	
}

void CEffectRepair::effectDelete(CDatabase *DB,int a)
{
	DB->effectDB.glMoveTo(this->setNum(a),effectPos);
	
	DB->effectDB.removeEffect(this->setNum(a));

}

void CEffectRepair::init(CDatabase *DB)
{
	for(int i=0;i<10;i++){
		DB->effectDB.createEffect(this->setNum(i),  "dat/effect/star-kaifuku0906-2.png" , 1 , 1 );
	DB->effectDB.setSize( this->setNum(i) , 100.0 , 100.0 );

	DB->effectDB.setRendMode(this->setNum(i));
	DB->effectDB.focusCamera( this->setNum(i) , DB->systemDB.getCamera() );
	}


	
	
}


std::string CEffectRepair::setNum(int a)
{
	std::string RepairN="Repair"+a;
 return RepairN;
}
