#include "effectThrowHit.h"

CEffectThrowHit::CEffectThrowHit(void)
{
	for(int i=0;i<6;i++){
	HitT[i]=-1;
	}
	HitN=0;
	
}

CEffectThrowHit::~CEffectThrowHit(void)
{
	
}



void CEffectThrowHit::effectSet(CDatabase *DB, fk_Model *Target)
{
	if(HitN>5){
		HitN=0;
	}
	effectPos=Target->getPosition();

	DB->effectDB.glMoveTo(this->setNum(HitN),(effectPos.x)+rand()%60-30,(effectPos.y)+rand()%60-30,(effectPos.z)-10);

	DB->effectDB.entryEffect(this->setNum(HitN));
	HitT[HitN]=30;


	HitN++;
}

void CEffectThrowHit::update(CDatabase *DB)
{

	for(int i=0;i<6;i++){

		if(HitT[i]>0){
HitT[i]--;
		DB->effectDB.focusCamera(this->setNum(i) , DB->systemDB.getCamera() );
		DB->effectDB.setScale(this->setNum(i),1.02,1.02);
		}
		
		if(HitT[i]==0){
				DB->effectDB.setScale(this->setNum(i),1/pow(1.02,30),1/pow(1.02,30));

			this->effectDelete(DB,i);
			HitT[i]=-1;

		}
	}
}

void CEffectThrowHit::effectDelete(CDatabase *DB,int a)
{
	DB->effectDB.glMoveTo(this->setNum(a),effectPos);
	
	DB->effectDB.removeEffect(this->setNum(a));

}

void CEffectThrowHit::init(CDatabase *DB)
{
	for(int i=0;i<6;i++){
		DB->effectDB.createEffect(this->setNum(i),  "dat/effect/ef_hit.png" , 1 , 1 );
	DB->effectDB.setSize( this->setNum(i) , 100.0 , 100.0 );
	DB->effectDB.setRendMode(this->setNum(i));
	DB->effectDB.focusCamera( this->setNum(i) , DB->systemDB.getCamera() );
	}
HitN=0;


	
}


std::string CEffectThrowHit::setNum(int a)
{
	std::string throwHitN="throwHit"+a;
 return throwHitN;
}
