//---------------------------------------------------
// C^[tFCX
//---------------------------------------------------

#pragma once

#include "common.h"
#include "database.h"

class CInterFace
{
private:
	CDatabase *DBP;

	double time;

	bool drawHelp;

	struct statusBase{
		int	stock, combo;
		double lifeRate, lifeRate_prev ,anima;
		bool prevCombo;
		int moveCombo, posXCombo;
	};

	statusBase p1_status;
	statusBase p2_status;

public:
	CInterFace();
	~CInterFace();

	void setGraph(CDatabase *DB);
	void updateGraph(CDatabase *DB);

	bool getHelp();
	void setHelp(CDatabase *DB,bool flag);
	void setTime(double argTime);
	void setP1_LifeRate(int p1_life , int  p1_lifeMax);
	void setP2_LifeRate(int p2_life , int  p2_lifeMax); 
	void setP1_Stock(int argP1_stock);
	void setP2_Stock(int argP2_stock);
	void setP1_Anima(double argP1_anima);
	void setP2_Anima(double argP2_anima); 
	void setP1_Combo(int argP1_combo);
	void setP2_Combo(int argP2_combo);

	void removeNageru_P2_Icon(CDatabase *DB);
	void removeRocking_P2_Icon(CDatabase *DB);

	void deleteImage(CDatabase *DB);
};
