//---------------------------------------------------
// ֌Wf[^x[X
//---------------------------------------------------

#pragma once

#include "common.h"
#include "../FKUT/Audio.h"

class CSoundDB
{
private:
	int		bgmVol ;
	int		seVol ;

	std::map<std::string , fk_AudioStream*>					bgm ;
	std::map<std::string , fk_AudioStream*>::iterator		bgmIte ;
	std::map<std::string , fk_AudioWavBuffer*>				se ;
	std::map<std::string , fk_AudioWavBuffer*>::iterator	seIte ;

public:
	CSoundDB();
	~CSoundDB();

	void	changeVolume( int bgmVolume , int seVolume );
	void	loadBGM( std::string name , std::string pass );
	void	loadSE( std::string name , std::string pass );
	void	playBGM( std::string name );
	void	playSE( std::string name );
	void	stopBGM( std::string name );
	void	stopSE( std::string name );
	void	stopAll();
	void	seekBGM( std::string name , double seekSecond );
	void	seekSE( std::string name , double seekSecond );
	void	deleteBGM( std::string name );
	void	deleteSE( std::string name );
	void	deleteAll();
	bool	findBGM( std::string name );
	bool	findSE( std::string name );

};
