//---------------------------------------------------
// Xe[WGfB^
//---------------------------------------------------

#pragma once

#include "sceneBase.h"

class CStageEditor : public CSceneBase
{
private:
	int				x , y , z , settingFlag , menuSelecter , fileNum ;
	bool			isMenu ;

	fk_Block		b , f ;
	fk_Model		cursolBlock , frameBlock ;
	fk_Material		normal , alpha , p[2] ;

	fk_Model		bgModel[6] ;
	fk_RectTexture	bgTex[6] ;

	struct	blockBase
	{
		int			x , y , z ;
		fk_Model	*model ;
	};
	std::vector<blockBase*>	block ;
	blockBase		pModel[2] ;

public:
	CStageEditor();
	~CStageEditor();

	void	init();
	bool	onPeriod();

	void	initEditor();
	void	changeBlock( int argX , int argY , int argZ );
	void	entryBlock();
	void	deleteField();
	void	loadBG();
	bool	loadEditorFile( int num );
	bool	saveEditorFile( int num );
	bool	findEditorFile( int num );

};
