#include "common.h"

CCamera::CCamera(void)
{
	camera.glMoveTo(0.0, 100.0, -300.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	moveModel.glMoveTo( 0.0, 100.0, -300.0);
	moveModel.glFocus(0.0, 0.0, 0.0);
	moveModel.glUpvec(0.0, 1.0, 0.0);

	prevPos = ( 0.0, 100.0, -300.0);

	return;
};

CCamera::~CCamera(void)
{
};

void CCamera::entryScene(fk_Scene *argScene)
{
	argScene->entryModel(&camera);
	
	return;
}

//Jf̃AhX擾
fk_Model * CCamera::getCameraModelAddress()
{
	return &camera;
}

//J̃f擾
fk_Model CCamera::getCameraModel()
{
	return camera;
}

//J̌擾
fk_Vector CCamera::getCameraVec()
{
	return camera.getVec();
}

//J̈ړiPȕsړ
/*
void CCamera::setCameraMove(double x, double y, double z)
{
	camera.glTranslate(x, y, z);
	return;
}
*/

//J̈ړivC[̔wƂ
void CCamera::getCameraMovePos(fk_Vector playerPos, fk_Vector playerVec, fk_Vector enemyPos)
{	
	camera.glMoveTo(playerPos);
	camera.glVec(playerVec);
	camera.loTranslate(0, 80, 250);
	camera.glFocus(enemyPos);
	camera.glUpvec(0.0, 1.0, 0.0);
	return;
}	

//J̏ݒ̏
void CCamera::initCamera()
{
	camera.glMoveTo(0.0, 100.0, -300.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	moveModel.glMoveTo( 0.0, 100.0, -300.0);
	moveModel.glFocus(0.0, 0.0, 0.0);
	moveModel.glUpvec(0.0, 1.0, 0.0);

	prevPos = ( 0.0, 100.0, -300.0);

	return;
}

//fobO
void CCamera::debug()
{
	printf( "%lf,%lf,%lf\n", camera.getPosition().x, camera.getPosition().y, camera.getPosition().z);
	return;
}