#include "common.h"

CEnemy::CEnemy(void)
{
	enemyObb.setBlockSize(30.0, 30.0, 30.0);
	enemyObb.setModel(&enemyModel);
	enemy.setSize(30.0, 30.0, 30.0);
	enemyModel.glMoveTo(0.0, 15.0, -120.0);
	enemyModel.setMaterial(Purple);
	enemyModel.setShape(&enemy);
	enemyModel.setSmoothMode(true);
	MaxHP = 50;	//őHP
	HP = MaxHP;
	isAlive = true;
	isDamage = false;
	damageCount = 0;
	invCount = 0;
	enemyAI = 0;

	return;
};

CEnemy::~CEnemy(void)
{
};

void CEnemy::entryScene(fk_Scene *argScene)
{
	argScene->entryModel(&enemyModel);
	
	return;
}

//G̈ʒu擾
fk_Vector CEnemy::getPos()
{
	return enemyModel.getPosition();
}

//Gf擾
fkut_OBB CEnemy::getEnemyObb()
{
	return enemyObb;
}

//vC[Ƃ̏Փˏ
bool CEnemy::checkCollision(fkut_OBB &playerOBB, fk_Vector *spd)
{
	static fk_Vector back, refV;
	bool hitFlag = false;

	enemyModel.setMaterial(Purple);

	// Փ˔̊Jn
	back.init();
	if(enemyObb.checkVSMovingOBB(playerOBB, (*spd)/*+back*/, refV)) 
	{
		back += -refV*30; //ubN葽߂ɔ
		if( back.y < 0 )
		{
			back.y = fabs( back.y );
		}	
		enemyModel.setMaterial(Violet); 
		hitFlag = true;
	}
	(*spd) += back;

	return hitFlag;
}

//Gւ̃_[W
void CEnemy::damageEnemy(double num)
{
	if(invCount < 1 )//GԂǂ
	{
		HP -= num;
		printf( "%lf\n", num);
		if(HP < 0)
		{
			HP = 0;
		}
		isDamage = true;
	}
	return;
}

//G̔_[W̉\
void CEnemy::setDamageState()
{
	if(isDamage == true )//_[W󂯂ĂƂ
	{
		if(damageCount > 10 )//10t[Ōɖ߂
		{
			isDamage = false;
			damageCount = 0;
		}
		
		//_[W󂯂Ă邱Ƃ\_ŏ
		if(damageCount % 4 == 0)
		{
			enemyModel.setMaterial(Purple);
		}
		else if(damageCount % 2 == 0)
		{
			enemyModel.setMaterial(DarkRed);
		}
		damageCount ++;
	}
	return;
}

//Gւ̖GԂ̐ݒ菈
void CEnemy::setInv()
{
	if(isDamage == true )//_[W󂯂Ă鎞
	{
		//80t[ŖGԏI
		if(invCount > 80 )
		{
			isDamage = false;
			invCount = 0;
		}
		
		//GԂ\_ŏccǃ_[WHĂ鎞ƈꏏ̕\
		if(invCount % 20 == 0)
		{
			enemyModel.setMaterial(Purple);
		}
		else if(invCount % 10 == 0)
		{
			enemyModel.setMaterial(DarkRed);
		}
		invCount ++;
	}
	return;
}	

//G̐S菈
void CEnemy::setAliveFlag()
{
	isAlive = true;
	if(HP <= 0)//łfalse
	{
		isAlive = false;
	}
	return;
}

//G̐S擾
bool CEnemy::getAliveFlag()
{
	return isAlive;
}

//GAIJEg̎擾
int CEnemy::getEnemyAI()
{
	enemyAI ++;
	return enemyAI;
}		

//G`攻菈
void CEnemy::drawEnemy()
{
	if( isAlive == true )//ĂΕ`
	{
		enemyModel.setDrawMode(FK_POINTMODE | FK_LINEMODE | FK_POLYMODE);
	}
	else
	{
		enemyModel.setDrawMode(FK_NONEMODE);	
	}
	return;
}

//HP̊擾
double CEnemy::getHPrate()
{
	double rate = 0;
	rate = HP / MaxHP;
	debugNum = rate;
	return rate;
}


//G̏ݒ̏
void CEnemy::initEnemy()
{
	MaxHP = 20;	//őHP
	HP = MaxHP;
	isAlive = true;
	isDamage = false;
	damageCount = 0;
	invCount = 0;
	enemyAI = 0;

	return;
}

//fobOp
void CEnemy::debug()
{
	printf( "%lf\n", debugNum);
	return;
}