#pragma once
#include "common.h"

class CPlayer {
private:
	//vC[f
	fk_Block		player;
	fk_Model		playerModel;
	fkut_OBB		playerOBB;

	//ړA@Ŏgϐ
	fk_Vector		spd, acc, view, norm, back, refV;
	fk_Vector		vec;
	fk_Matrix		rotMat;

	//Uf
	fk_Model		parentAttackModel;
	fk_Block		attack;
	fk_Model		attackModel;
	fkut_OBB		attackOBB;

	//ef
	fk_Prism		shadow;
	fk_Model		shadowModel;
	fkut_OBB		shadowOBB;

	fk_Vector		shadowSpd;

	bool			isJump;		//Wvǂ
	bool			isDash;		//_bVǂ
	int				dashCount;	//_bVɂ镽sړs\Ԃ̐ݒ
	bool			isDamage;	//_[Wǂ
	bool			isCanMove;	//\ǂ
	int				invCount;	//GԂ̐ݒ
	double				MaxHP;		//g̍ő僉Ct
	double				HP;			//g̃Ct
	bool			isAlive;	//Ă邩ǂ

	bool			isInputAttack;	//U̓͂ꂽǂ
	int				stepAttack;		//UĂ邩ǂA܂̍U̒iK
	int				attackCount;	//UɊւ鎞Ԑݒ
	bool			isHitAttack;	//U肪邩ǂ

	int				comboNum;		//R{
	int				comboCount;		//R{sł邩ǂ܂ł̃JEg
	double			comboBonus;		//R{ɂ_[W{[iX
	int				attackDamage;	//_[W

	double			debugNum;

public:
	CPlayer();
	~CPlayer(void);

	void entryScene(fk_Scene *argScene);
	void removeScene(fk_Scene *argScene);

	fk_Vector getPos();						//ʒuW擾
	void setView(fk_Vector cameraVec);		//is菈
	void initSpd();							//n㎞͓x^A󒆂ł͉x
	
	fkut_OBB	getOBB();	//OBB擾
	fk_Vector * getPSpd();	//*spd擾
	fk_Vector	getSpd();	//spd擾

	bool getIsJump();				//isJump̎擾
	void jumpAction(bool isLift);	//Wv̍sitgǂɂƂ

	bool getIsCanMove();			//\ǂ̔
	void moveAction(int direct);	//ړ̍siL[{[ĥ݁H
	void normSpd();					//Xs[hʏ퉻̒l̐ݒ
	void setGravity();				//d͂̉e
	void addAcc();					//x𑬓xɏ悹
	
	bool getIsDash();				//_bVĂ邩ǂ̔
	void setIsDash();				//_bV֐ݒ
	void dashAction();				//_bV̍s
	void setPosY(bool isPlus);		//Փˎ̂YWvXCiԂh~
	void initAcc();					//Փˎx
	
	bool getDamageState();			//_[W󂯂Ă邩̔ƃ_[W̏
	void setDamageState(int num);	//_[WԂ̐ݒ菈

	void translatePlayerY();			// x𑀍샂fɉĎۂɓ(Y
	void translatePlayerXZ();			// x𑀍샂fɉĎۂɓ(XZ

	fk_Vector getPlayerVec();		//vČ擾
	void setVecEnemy(fk_Vector pos);//GɌČύX

	int	 getIsAttack();					//UĂ邩ǂ̔
	void setAttackVec(fk_Vector vec);	//Uf̌ύX
	void setAttack();					//ߐڍU̐ݒ
	void attackAction();				//ߐڍȔ
	bool checkAttackCollision(fkut_OBB &hitOBB, fk_Vector *spd);	//UՓ˔菈

	bool setFallState();	//vC̏

	void setCombo();			//R{֘Ȁ
	void addLifThrowCombo();	//ɂR{
	int	 getComboNum();			//R{擾
	double getComboBonus();	//R{{[iX{擾

	double  getAttackDamage();	//_[Wl̎擾

	void moveShadow();	//ëړ

	double getHPrate();		//HP̊擾

	void	setAliveFlag();	//Ԃ̐ݒ菈
	bool	getAliveFlag();	//Ԃ̎擾

	void drawPlayer();	//vC̕`攻

	void initPlayer();	//vCNX̏ݒ̏

	void debug();	//fobOp
};