#include "common.h"

CSound::CSound(void)
{
	if( !stageBGM.open( "music/INNOCENT_FLIER_100904.ogg" ) )	fl_alert( "error read[INNOCENT_FLIER_100904.ogg]" );
	stageBGM.setLoopMode(true);
	isPlayStageBGM = true;

	if( !jumpSE.open( "music/jump.wav" ) )	fl_alert( "error read[jump.wav]" );
	if( !damageSE.open( "music/damage.wav" ) )	fl_alert( "error read[damage.wav]" );
	if( !liftSE.open( "music/get.wav" ) )	fl_alert( "error read[get.wav]" );
	if( !fallSE.open( "music/fall.wav" ) )	fl_alert( "error read[fall.wav]" );
	if( !slashSE.open( "music/tm2_slash000.wav" ) )	fl_alert( "error read[tm2_slash000.wav]" );
	if( !throwSE.open( "music/tm2_gun000.wav" ) )	fl_alert( "error read[tm2_gun000.wav]" );
	return;
};

CSound::~CSound(void)
{
};

void CSound::playStageBGM()
{
	stageBGM.play();
	isPlayStageBGM = true;
	return;
}

void CSound::stopStageBGM()
{
	stageBGM.stop();
	stageBGM.seek( 0.0 );
	isPlayStageBGM = false;
	return;
}

bool CSound::getPlayStageBGM()
{
	return isPlayStageBGM;
}

//WvSEĐ
void CSound::playJumpSE()
{
	jumpSE.seek( 0.0 );
	jumpSE.play();
	return;
}

//_[WSEĐ
void CSound::playDamageSE()
{
	damageSE.seek( 0.0 );
	damageSE.play();
	return;
}

//ubNグSEĐ
void CSound::playLiftSE()
{
	liftSE.seek( 0.0 );
	liftSE.play();
	return;
}

//SEĐ
void CSound::playFallSE()
{
	fallSE.seek( 0.0 );
	fallSE.play();
	return;
}

//ߐڍUSEĐ
void CSound::playSlashSE()
{
	slashSE.seek( 0.0 );
	slashSE.play();
	return;
}

//SEĐ
void CSound::playThrowSE()
{
	throwSE.seek( 0.0 );
	throwSE.play();
	return;
}

//TEhiS~
void CSound::initSound()
{
	isPlayStageBGM = true;

	stageBGM.stop();
	stageBGM.seek( 0.0 );
	jumpSE.stop();
	jumpSE.seek( 0.0 );
	damageSE.stop();
	damageSE.seek( 0.0 );
	liftSE.stop();
	liftSE.seek( 0.0 );
	fallSE.stop();
	fallSE.seek( 0.0 );
	return;
}

//fobO
void CSound::debug()
{
	printf( "%d\n", isPlayStageBGM);
	return;
}