#pragma once
#include "common.h"

class CEnemy {
private:
	//Gf
	fk_Block	enemy;		
	fk_Model	enemyModel;

	fkut_OBB	enemyObb;

	fk_Vector	spd;

	//ef
	fk_Prism		shadow;
	fk_Model		shadowModel;
	fkut_OBB		shadowOBB;

	fk_Vector		shadowSpd;

	double		MaxHP;		//MaxHP
	double		HP;			//HP
	bool		isAlive;	//tO
	
	bool		isDamage;	//UĂ邩ǂ
	int			damageCount;//_[W\Ԃ̃JEg
	int			invCount;	//GԂ̃JEg

	int			enemyAI;	//GAIJE^
	int			attackPattern;	//G̍U@

	int			actCount;	//s̃JE^
	int			movePattern;//ړ@
	
	bool		judgeTurnToPlayer;	//vC[̕ɕ]邩
	bool		isDamageBody;		//̂ɍU肪邩ǂ
 	bool		hitFlagToBlock;		//ubNƂԂĂ邩
	

	enum Enemy_MotionStatus
	{
		ENEMY_STOP = -1,
		ENEMY_WARP,		//0
		ENEMY_MOVE,		//1
		ENEMY_FALL_S,	//2
		ENEMY_FALL,		//3
		ENEMY_ATTACK_W,	//4
		ENEMY_ATTACK_H,	//5
		ENEMY_ATTACK_M,	//6
	};

	Enemy_MotionStatus motionID;

	int		debugNum;
	
public:
	CEnemy(void);
	~CEnemy(void);

	void entryScene(fk_Scene *argScene);
	void removeScene(fk_Scene *argScene);

	fk_Vector * getPSpd();	//*spd擾

	fk_Vector	getPos();	//G̈ʒu擾
	fkut_OBB getEnemyObb();	//Gf擾
	fk_Vector getVec();		//Ǧ擾

	bool checkCollisionToPlayer(fkut_OBB &playerOBB, fk_Vector *spd); //vC[Ƃ̏Փˏ
	
	void damageEnemy(double num);	//Gւ̃_[W
	void setDamageState();		//G̔_[W̉\
	void setInv();				//Gւ̖GԂ̐ݒ菈
	void setAliveFlag();		//G̐S菈
	bool getAliveFlag();		//G̐S擾

	void judgeHitToBlock();	//ƓĂ邩̔

	void focusToPlayer(fk_Vector pos);	//vC[̕֌

	bool getIsDamageBody();	//G̑̂ɍU肪邩ǂ̎擾
	void plusAICount();		//GAIJEg̑ƍsp^[̌
	void actAI();			//肳ꂽsp^[ɂčs
	int getAIPattern();		//GAIJEg̎擾

	void initHitFlagToBlock();//Ƃ̏Փˊm

	void moveShadow();	//ëړ

	double getHPrate();		//HP̊擾

	void drawEnemy();		//G`攻菈

	void initEnemy();		//G̏ݒ̏

	void debugHitCheck();	//蔻fobOp

	void debug();				//fobOp
};