#pragma once
#include "common.h"

class CField {
private:
	static const int	blockNum = 81;//ubN邩
	fk_Block		block[blockNum];
	fk_Model		blockModel[blockNum];
	
	fkut_OBB		obb[blockNum];

	CMotionCharactor		blockObj[blockNum];
	CMotionCharactor		standBlockObj;


	fk_RectTexture		bgTex[6] ;
	fk_Model			bgModel[6] ;

	int				judgeCatch[blockNum];//0:グς݁A1Fグ
	int				judgeStand;		//ǂ̑̏ɏĂ邩
	int				prevJudgeStand;	//ǂ̑̏ɏĂ

	int				repairBlockNum[blockNum];	//p̓YLpz
	
	fk_Vector		spd;			//GƂ̏Փˌmp

	bool			judgeShadow;	//eɂ܂ĂȂ
	int				judgeLimit;		//Փ˔̌JԂ̌El
	int				debugNum;		//fobOL[			
	
public:
	CField(void);
	~CField(void);

	bool checkCollisionToPlayer(fkut_OBB &playerOBB, fk_Vector *spd);//vCƂ̏Փˏ
	bool checkCollisionToEnemy(fkut_OBB &enemyOBB, fk_Vector *spd);//GƂ̏Փˏ
	
	fk_Vector * getPSpd();	//*spd擾
	fkut_OBB getObb(int num);	//obb擾

	int	getBlockNum();	//ubN擾

	void entryScene(fk_Scene *argScene);
	void removeScene(fk_Scene *argScene);

	int  getJudgeCatch(int blockNum);//͂߂鑫ꂩǂ
	void setBlockCatch(fk_Scene *argScene);//񂾃ubÑtO

	void drawBlockObj();	//ubÑIuWFNgf[^̈ʒu
	void updateBlockObj(fk_Scene *argScene);	//ubÑIuWFNg̃[uƃGg[
	void drawBlock();		//ubN`攻菈

	void repairBlock(fk_Scene *argScene);		//Aj}ɂ鑫̕

	void initField();		//tB[h̏ݒ菉

	void debugHitCheck();		//蔻̃IItfobO

	void debug();				//fobOp

};
