#pragma once
#include "common.h"

class CLifThrow {
private:

	fk_Model	parentLiftBlockModel;	//グubN]p̐ef
	fk_Block	liftBlock[6];			//グubN	
	fk_Model	liftBlockModel[6];
	fkut_OBB	liftObb[6];

	fk_Model	parentThrowBlockModel;//グubN]p̐ef
	fk_Block	throwBlock[6];        //ubN
	fk_Model	throwBlockModel[6];
	fkut_OBB	throwObb[6];

	CMotionCharactor		liftBlockObj[6];
	CMotionCharactor		throwBlockObj[6];

	bool		isLiftBlockFlag[6];		//ubNグĂ邩ǂ
	bool		isThrowBlockFlag[6];	//ubN𓊂Ă邩ǂ
	int			liftBlockCount;			//ubNグ
	
	bool		isHitThrowBlock[6];		//ubNɓ蔻肪邩ǂ
	double		throwBlockDistance[6];	//ubNƃvCƂ̋
	fk_Vector	throwBlockSpd;			//ubN̉x

	int			attackDamage;

public:
	CLifThrow(fk_Vector pos);
	~CLifThrow(void);

	void entryScene(fk_Scene *argScene);
	void removeScene(fk_Scene *argScene);

	void rotationLiftBlock();			//グubN]
	void setLiftBlockPos(fk_Vector pos);//グAubN̐efړ

	void drawLiftBlock();						//グubN`攻菈
	void setLiftBlockNum(fk_Scene *argScene);	//グubN̈ʒuA܂グ\ǂ̔菈

	void drawThrowBlock();				//ubN`攻菈
	void setThrowAngle(fk_Vector pos, fk_Scene *argScene);	//P̓ubNppx擾AubNړJn
	void setThrowVector();				//ubNx
	void setThrowBlockFlag(fk_Scene *argScene);			//OėꂷubN̏tO	

	fkut_OBB getThrowObb(int num);			//ubNf̃AhX擾
	fk_Vector * getThrowBlockSpdAddress();	//ubN̉x̃AhX擾

	void summonAnima(fk_Scene *argScene);	//Aj}̎グubN̏

	int getLiftBlockCount();	//グubN̎擾

	bool checkCollision(int num, fkut_OBB &hitOBB, fk_Vector *spd, fk_Scene *argScene);	//Փ˔菈iՓˎ̓ubN܂

	double  getAttackDamage(double comboBonus);	//_[Wl̎擾

	void decLiftBlock(fk_Scene *argScene);	//ߐڍŨubN

	void drawBlockObj();	//ubÑIuWFNgf[^̈ʒu
	void updateBlockObj(fk_Scene *argScene);	//ubÑIuWFNg̃[uƃGg[

	void initLifThrow();	//tX[NX̏ݒ̏

	void debug();				//fobOp
};